# $Log: not supported by cvs2svn $
# Revision 1.51  2007/06/12 19:31:03  soliday
# Updated to work with the new LEULT_Configure machine procedure.
#
# Revision 1.50  2007/02/27 18:25:10  soliday
# It now suspends K1, K2, and K3 controllaws at the end.
#
# Revision 1.49  2007/02/27 18:19:27  soliday
# Changed the default for switching back to the gun so that it does not
# start L3
#
# Revision 1.48  2006/10/23 15:21:35  soliday
# Improved an error message explaining why it could not detect the
# selected gun.
#
# Revision 1.47  2004/11/01 20:00:12  soliday
# Changed modulator labels
#
# Revision 1.46  2004/06/30 14:53:12  soliday
# It now forces the user to select an SCR file.
#
# Revision 1.45  2004/01/29 17:04:16  soliday
# Updated with more error/warning dialogs.
#
# Revision 1.44  2004/01/26 22:31:17  soliday
# Modified APSPEMTKDialog and increased the number of places where it
# is used.
#
# Revision 1.43  2003/10/27 20:22:19  soliday
# Replaced existing warning dialogs with calls to APSPEMTKDialog.
# Added logging of the selections on the initial dialog.
#
# Revision 1.42  2003/10/14 21:04:14  soliday
# Removed warning about current below 1nC.
#
# Revision 1.41  2003/04/15 18:17:18  soliday
# Modified the description of RFGUN_ChangeTiming
#
# Revision 1.40  2003/03/25 18:26:45  soliday
# The PV to determine PAR inclusion or bypass is not in the SCR files.
#
# Revision 1.39  2003/03/25 17:27:05  soliday
# Added LTP and PTB startup
#
# Revision 1.38  2003/03/25 16:40:36  soliday
# The PCGUN switch over routines now bring down the PFN voltage on 1 2 and 3.
#
# Revision 1.37  2003/03/25 16:27:37  soliday
# Worked out more kinks during studies.
#
# Revision 1.36  2002/10/10 21:25:22  soliday
# Commited changes after PEM studies.
#
# Revision 1.35  2002/07/15 21:17:44  borland
# Fixed bugs introduced in previous change.
#
# Revision 1.34  2002/07/15 20:50:35  borland
# Fixed a typo.
#
# Revision 1.33  2002/07/15 15:55:05  borland
# Kludged up so that L2 and L3 are brought down prior to the waveguide switch.
# Added switching of power controllaw rates and 60s wait while the controls
# work (may not be long enough).
#
# Revision 1.32  2002/07/15 00:21:17  borland
# PC gun to RFG switching now takes down power on L1, L2, and L3, as well as
# their PFNs.
#
# Revision 1.31  2002/07/11 20:04:10  soliday
# Added the ability to set the mode on the modulators.
#
# Revision 1.30  2002/05/29 16:52:50  soliday
# Commited changes made during PEM studies.
#
# Revision 1.29  2002/05/23 21:48:31  soliday
# Temporary version.
#
# Revision 1.28  2002/04/24 22:46:57  soliday
# Commented out AsyncRFRate switch.
#
# Revision 1.27  2002/01/10 22:51:30  soliday
# Fixed error messages for PCGUN_SwitchOverToRFGunWithPS
#
# Revision 1.26  2001/08/08 23:49:27  soliday
# Changed waveguide dialog for switch over.
#
# Revision 1.25  2001/08/02 20:24:34  soliday
# L4 and L5 power controls automatically suspend once operating value is attained.
#
# Revision 1.24  2001/05/31 18:19:11  soliday
# The RF auto phase now starts after the switch over. The L4 and L5 power
# controllaws are disabled after the switch over. The dialog box for the
# waveguide switch has been removed.
#
# Revision 1.23  2001/03/01 20:05:09  soliday
# Added the ability to select individual power supplies.
#
# Revision 1.22  2001/02/07 21:51:59  soliday
# Did more pem testing. Also used procheck to clean up code.
#
# Revision 1.21  2000/12/04 23:51:20  soliday
# Fixed dialog messages.
#
# Revision 1.20  2000/12/04 22:52:10  soliday
# New versions tested in control room.
#
# Revision 1.19  2000/11/08 16:29:58  soliday
# It is no longer required to bring the modulators down to ready to pulse.
#
# Revision 1.18  2000/09/26 18:40:50  soliday
# PCGUN_SwitchOverToRFGunWithPS now allows the user to select power supply
# groups like the other PEMs.
#
# Revision 1.17  2000/07/26 21:33:01  soliday
# Fixed bug with cavput call
#
# Revision 1.16  2000/07/25 19:31:51  soliday
# Added L3 power supplies
#
# Revision 1.15  2000/06/17 22:32:52  borland
# When bringing up RG1, no longer standardize RG2:LFA.  Instead, degauss
# RG2:LFA:TRM.
#
# Revision 1.14  2000/05/25 22:37:36  soliday
# It now presses the reset switch for L1:IC1:WS1 after checking the fault
# reset switch on the L1_WS1 screen.
#
# Revision 1.13  2000/05/25 21:50:28  soliday
# Commiting for testing after shutdown period.
#
# Revision 1.12  2000/03/06 16:43:59  soliday
# I now use sddsselect to filter the SCR file.
#
# Revision 1.11  2000/02/10 21:32:28  soliday
# It no longer starts the power control law for L3.
#
# Revision 1.10  2000/02/09 22:01:08  soliday
# Added prompt when PFN voltage is outside limits in SCR file.
#
# Revision 1.9  2000/01/27 18:39:24  soliday
# Added some procedures that will allow shutdown of the PAR at the same time.
#
# Revision 1.8  1999/12/17 20:51:13  soliday
# Changed name of procedure.
#
# Revision 1.7  1999/12/15 22:30:04  soliday
# The script should not just bomb out without first giving the operator a chance
# to fix the problem.
#
# Revision 1.6  1999/12/13 19:58:39  soliday
# Added description lines
#
# Revision 1.5  1999/12/10 16:24:27  soliday
# Added much longer wait time for water heater reset
#
# Revision 1.4  1999/12/09 16:40:50  soliday
# All modulators are choosen by default. Longer wait time for the water heater
# reset switch
#
# Revision 1.3  1999/12/08 20:51:29  soliday
# Fixed a joining problem
#
# Revision 1.2  1999/12/07 15:47:30  soliday
# All modulators get turned off no matter what the user picks
#
# Revision 1.1  1999/12/06 20:26:41  soliday
# First working version of PCGUN_Shutdown
#
#

proc RFGUN_ChangeTimingInfo {} {
    return "RFGUN Change Timing Procedure\n\
\n\
This is called by:\n\
PCGUN_SwitchOverToRFGunWithPS\n\
\n\
This procedure does the following:\n\
1. Sets the Laser trigger to \"Test Stand RF\".\n\
2. Changes the beam trigger timing to 2Hz.\n\
3. Changes the Timing Reference Source to \"PAR RF\".\n\
4. Changes the beam trigger timing to 10Hz.\n\
5. Sets timing source to \"LI Async Rate\".\n\
6. Depresses the \"Set Timing for RF-Gun and Kicker\" button."
}

proc RFGUN_ChangeTimingDialog {frame} {
    APSSetVarAndUpdate status "Click OK to set timing for RF-Gun"
    pack [message $frame.msg -aspect 300 -justify left \
	      -text "Click OK to set timing for RF-Gun"]
    return
}

proc RFGUN_ChangeTiming {args} {
    global execMode
    set includePar 1
    set bypassPar 0
    
    if {$execMode == "Manual"} {
	set prefix "Press Continue to "
    } else {
	set prefix ""
    }

    APSStrictParseArguments {includePar bypassPar}
    APSMpStep init -promptDialog RFGUN_ChangeTimingDialog

    set paramString ""
    foreach param {includePar bypassPar} {
        append paramString "$param=\"[set $param]\" "
    }
    catch {APSLogScriptAction -procedure RFGUN_ChangeTiming -action initialize -state ok -parameters $paramString}

    if [catch {APSLinkToLINACPVs} result] {
	APSMpReturn error "RFGUN_ChangeTiming: $result"
    }

    APSMpStep "${prefix}Set Laser trigger to Test Stand RF" \
	-desc "Set Laser trigger to Test Stand RF"
    if [catch {APSPCGUN_SetLaserTrigger -state "TestStandRF"} result] {
        if {[APSPEMTKDialog .warningDialog -text "Unable set Laser trigger to Test Stand RF\n$result"] == 1} {
            APSMpReturn error "RFGUN_ChangeTiming: $result"
        }
#	APSMpReturn error "RFGUN_ChangeTiming: $result"
    }
#    APSMpStep "${prefix}Change the Beam Trigger Timing to 2Hz on the Linac Injection Sequence Screen" -desc "Change the Beam Trigger Timing to 2Hz on the Linac Injection Sequence Screen"
#    if [catch {APSLINAC_SetBeamTriggerRate -state "--2Hz--"} result] {
#        if {[APSPEMTKDialog .warningDialog -text "Unable change the Beam Trigger Timing to 2Hz on the Linac Injection Sequence Screen\n$result"] == 1} {
#            APSMpReturn error "RFGUN_ChangeTiming: $result"
#        }
#    }
    APSMpStep "${prefix}Change the Timing Reference Source to PAR RF" \
	-desc "Change the Timing Reference Source to PAR RF"
    if [catch {APSLINAC_SetInjectionTimingTrigger -state PAR} result] {
        if {[APSPEMTKDialog .warningDialog -text "Unable change the timing Reference Source to PAR RF\n$result"] == 1} {
            APSMpReturn error "RFGUN_ChangeTiming: $result"
        }
#	APSMpReturn error "RFGUN_ChangeTiming: $result"
    }
    if {[catch {exec cavget -list=It:ByPassParC -num -pend=20} currentParState]} {
        APSMpReturn error "RFGUN_ChangeTiming: $currentParState"
    }
    APSMpStep "${prefix}Set the PAR Inc/Exc PV" -desc "Set the PAR Inc/Exc PV"
    if {$includePar} {
        if {$currentParState != 0} {
            if {[catch {exec cavput -list=It:ByPassParC=0 -num -pend=20} results]} {
                if {[APSPEMTKDialog .warningDialog -text "Unable to switch to Include Par\n$results"] == 1} {
                    APSMpReturn error "RFGUN_ChangeTiming: $results"
                }
#                APSMpReturn error "RFGUN_ChangeTiming: Unable to switch to Include Par"
            }
        }
#        APSMpStep "${prefix}Change the Beam Trigger Timing to 10Hz on the Linac Injection Sequence Screen" -desc "Change the Beam Trigger Timing to 10Hz on the Linac Injection Sequence Screen"
#        if [catch {APSLINAC_SetBeamTriggerRate -state {{RFG 10hz}}} result] {
#            if {[APSPEMTKDialog .warningDialog -text "Unable change the Beam Trigger Timing to 10Hz on the Linac Injection Sequence Screen\n$result"] == 1} {
#                APSMpReturn error "RFGUN_ChangeTiming: $result"
#            }
#        }
        APSWaitWithUpdate -waitSeconds 2
        catch {exec cavput -list=It:L:B06_enb_bo.VAL=0,It:L:B08_enb_bo.VAL=0 -num -pend=20}
    } elseif {$bypassPar} {
        if {$currentParState != 1} {
            if {[catch {exec cavput -list=It:ByPassParC=1 -num -pend=20} results]} {
                if {[APSPEMTKDialog .warningDialog -text "Unable to switch to Bypass Par\n$results"] == 1} {
                    APSMpReturn error "RFGUN_ChangeTiming: $results"
                }
#                APSMpReturn error "RFGUN_ChangeTiming: Unable so switch to Bypass Par"
            }
        }
    }
    APSMpStep "${prefix}Depress the \"Set Timing for RF-Gun and Kicker\" button" \
	-desc "Depress the \"Set Timing for RF-Gun and Kicker\" button"
    if [catch {APSPCGUN_SetTimingForRFGun} result] {
        if {[APSPEMTKDialog .warningDialog -text "Unable to set timing for RF-Gun and kicker\n$result"] == 1} {
            APSMpReturn error "RFGUN_ChangeTiming: $result"
        }
#	APSMpReturn error "RFGUN_ChangeTiming: $result"	
    }
    if {[catch {exec cavput -list=L1:RFG:KIK:chargeTimePD.GATE=1 -pend=20} results]} {
	bell
        if {[APSPEMTKDialog .warningDialog -text "Unable to set L1:RFG:KIK:chargeTimePD.GATE=1\n$results"] == 1} {
	    APSMpReturn error "RFGUN_ChangeTiming: Unable to set L1:RFG:KIK:chargeTimePD.GATE to 1 : $results"
	}
    }
    APSMpReturn ok
}

