
#
# $Log: not supported by cvs2svn $
# Revision 1.98  2011/01/26 21:10:13  shang
# added S29 to cerenkov dector setup.
#
# Revision 1.97  2010/11/30 18:40:57  shang
# modified SetGapTo60mm pem to not moving the gaps whose present values are greater than the desired values.
#
# Revision 1.96  2010/07/27 20:19:24  shang
# added missing label for "setup cerenkov detector"
#
# Revision 1.95  2010/07/27 18:25:40  shang
# use "APSMpReturn" instead of "return" for APSSetupSRCerenkovDector so that it can be ran as pem.
#
# Revision 1.94  2010/07/27 18:23:32  shang
# added "APSMpReturn ok" to APSSetupSRCerenkovDector procedure.
#
# Revision 1.93  2010/07/27 18:12:17  shang
# added setup cerenkov dector in the end of switch to user mode pem.
#
# Revision 1.92  2010/05/27 16:21:54  shang
# due to higher amount of forward power needed if close all gaps, now split the xbpm reference gaps into group a and b, user may choose \
# which group (A or B) to restore, or restore all gaps (both) if allowed.
#
# Revision 1.91  2010/03/26 18:45:17  shang
# added procedures for CPU IOC reboot pem.
#
# Revision 1.90  2009/07/03 03:46:55  shang
# fixed a typo
#
# Revision 1.89  2009/06/10 18:15:08  shang
# changed the comment for SCR save per Karen's request
#
# Revision 1.88  2009/02/16 22:47:48  shang
# added ShortFilename argument to APSMpIDRestoreGapsFromSCR so that it can restore the ID gaps from provided SCR file.
#
# Revision 1.87  2009/02/13 14:56:46  shang
# modified the APSMpRestoreIDGapFromSCR pem to be able to be called as non-pem procedure.
#
# Revision 1.86  2008/11/19 04:48:17  emery
# Untabified.
#
# Revision 1.85  2008/10/14 14:08:02  shang
# modified to be able to staggering return gaps (skip checking the gap setpoint and gap readback in this case)
#
# Revision 1.84  2008/09/29 22:20:53  shang
# added checking if gap is already there in staggering close to avoid unnecessary waiting.
#
# Revision 1.83  2008/09/25 16:28:28  shang
# changed the wait time for set 180mm gap to 0.1 seconds (do not need wait for opening gaps.)
#
# Revision 1.82  2008/09/25 15:37:36  shang
# modified to stagger closing the gaps.
#
# Revision 1.81  2008/07/16 16:29:32  shang
# added -printErrors to cavget statement so that it returns error message if there is problem in reading pv values.
#
# Revision 1.80  2008/07/16 16:18:31  shang
# now uses APSMpReturn for return statement in APSMpCheckAndWaitForIDs procedure
#
# Revision 1.79  2008/07/03 16:27:35  shang
# put the tolerance back (forgot to remove it after debugging)
#
# Revision 1.78  2008/07/03 16:22:11  shang
# now label the error message in checking ID gaps procedure to catch the segmentation fault (it happened sometimes, but repeatable)
#
# Revision 1.77  2008/07/03 15:12:46  shang
# removed the popup dialog box in APSMpCheckAndWaitForIDs procedure
#
# Revision 1.76  2008/07/03 14:43:36  shang
# added checking the device status in APSCheckAndWaitForIDs
#
# Revision 1.75  2008/03/05 20:08:53  shang
# added using caput for setting ID:AccessSecurity pv if cavput failed and added "stop" commands before
# starting moving ID gaps in APSIDsGoAndWait since it sometimes helps the stalled gaps.
#
# Revision 1.74  2008/02/05 16:14:22  shang
# labeled the error message and changed the restore user gaps pem to not check the ID gaps if gaps are not issued to move, and used the global command for open gaps in switch to machine physics pem; tested with Karen.
#
# Revision 1.73  2007/12/11 15:48:18  shang
# added distinguished number to return error message for APSMpCheckAndWaitForIDs proc for easy debug.
#
# Revision 1.72  2007/11/15 20:38:18  shang
# modified switch to user mode pem: set the global switch to machine physics and then set to user mode  so that the global close can take effect.
#
# Revision 1.71  2007/10/10 15:12:47  shang
# added setting ID:AccessSecurity to user mode before returning the gaps in switch to user mode pem.
#
# Revision 1.70  2007/07/25 14:30:33  shang
# fixed a typo in APSMpCheckAndWaitForIDs proc and added TestCheckIDPem for testing it.
#
# Revision 1.69  2007/07/17 15:05:42  shang
# 1)added checking difference of gap setpoint and readback in  APSMpCheckAndWaitForIDs before return.2)added full arguments to APSIDGetDeviceList and APSIDGetTaperDeviceList, if full is set 0, then only devices whose motore status are enabled will be return; if full is 1, then return the full list. 3)modified the APSMpIDRestoreGaps and APSMpIDRestoreGapsFromSCR to ignore the gaps whose motore status are disabled so that user does not have to wait for the disabled gaps.
#
# Revision 1.68  2007/04/17 14:46:18  shang
# modified APSMpCheckAndWaitForIDs to use Message1.VAL only for determing if gap moved to destination.
#
# Revision 1.67  2007/02/27 18:01:31  shang
# tested new checking ID gaps moving procedure and pem initialize logging.
#
# Revision 1.66  2006/11/01 11:38:45  emery
# Changed the paths for the default files of the PCU
# correction in APSMpCPUInitialize
#
# Revision 1.65  2006/06/27 18:31:39  shang
# added APSMpIDRestoreGapsFromSCR which restores the gap setpoints and taper gap setpoints.
#
# Revision 1.64  2006/04/19 08:41:21  emery
# Shang's addition: APSMpResetCPUAfg
#
# Revision 1.63  2006/01/30 09:37:32  emery
# Fixed scan command in APSIDsGoAndWait.
#
# Revision 1.62  2005/12/13 15:50:19  asdops
# modified restore user gaps pem to restore the gap modes after restoring and
# added restore xray bpm reference gaps option to switch to machine physics modepem.
#
# Revision 1.61  2005/09/23 22:27:30  shang
# replaced invidual simplex init dialog box by common APSMpPromptInitDialog
#
# Revision 1.60  2005/09/23 21:06:22  shang
# added prompting dialog box with simple message "Click Ok to execute" to those pems
# that do not have prompting dialog box.
#
# Revision 1.59  2004/10/19 18:41:43  shang
# added SCR save of SRXrayBPM before switching to machine physics mode and
# added APSMpSetGapToMinimum proc
#
# Revision 1.58  2004/07/26 19:53:18  shang
# added SCR save before and after switching to machine physics mode and added
# checking difference between gap/taper setpoint and readback values before
# setting gap/taper return values.
#
# Revision 1.57  2004/06/03 15:54:54  shang
# added checking the difference of gap/taper setpoint and current values before setting
# the gap/taper return values to the setpoint values in SwitchToUserMode pem when "no" is
# selected.
#
# Revision 1.56  2004/03/30 19:36:54  shang
# added setting GapReturn and TaperTurn values to current Gap and Taper Values if
# no is chosen in APSSwitchToUserMode pem and skip the manager (not user) mode in
# APSSwitchToMachinePhysicsMode pem if no is chosen for "open gaps"
#
# Revision 1.55  2004/03/22 16:31:05  shang
# added setting ID taper to zero before moving gaps in APSMpIDRestoreGaps proc
#
# Revision 1.54  2003/12/09 16:54:42  shang
# modified APSIDGoAndWait and APSIDsGoAndWait proc to display ID
# name and the difference whose value is bigger and make it more efficient
#
# Revision 1.53  2003/10/21 20:12:40  shang
# modified restore gaps procedure to use the updated APSFileDisplayWindow with
# Ok and Cancel buttons.
#
# Revision 1.52  2003/10/13 19:31:24  shang
# added the removed APSMpIDRestoreXbpmRefGaps proc which was removed by mistake
#
# Revision 1.51  2003/10/13 19:22:09  shang
# added printouts for current gap values and the values that gaps are going to
# be moved to for moving gap pem.
#
# Revision 1.50  2003/08/13 14:31:44  shang
# fixed the type error Minumum, should be Minimum
#
# Revision 1.49  2003/08/08 14:39:40  shang
# added APSMpIDRestoreMinimumGaps, APSMpIDRestoreXbpmGaps,APSMpIDRestoreOpenGaps
#
# Revision 1.48  2003/06/09 14:42:30  shang
# added one minute delay after closing gaps in switch to user mode and a checking dialog box
#
# Revision 1.47  2003/06/09 14:34:16  shang
# added one minute delay after open gaps and a checking dialog box to check
# if all gaps stop moving and switching to machine physics mode is done
#
# Revision 1.46  2003/06/09 14:22:38  shang
# added sleeping one minute after switching to machine physics mode
#
# Revision 1.45  2003/06/09 14:11:37  shang
# added dialogbox to check if switching gaps is done
#
# Revision 1.44  2003/03/20 21:42:25  emery
# Fixed help message typos.
#
# Revision 1.43  2003/03/20 21:32:32  emery
# Added return statement after alert box and at end of procedure for procedure
# APSMpCPUInitialize
#
# Revision 1.42  2003/03/20 21:29:16  emery
# Fixed missing bracket bugs.
#
# Revision 1.41  2003/03/20 21:18:38  emery
# Added procedures APSMpCPUInitialize to make sure the
# CPU ioc is loaded with the correct compensation files.
#
# Revision 1.40  2002/07/16 20:30:32  borland
# Improved the info messages.
#
# Revision 1.39  2002/06/18 19:45:09  borland
# Added APSMpIDTimeRestoreUserGaps and related InitDialog and Info routines.
#
# Revision 1.38  2002/06/18 18:35:24  borland
# Added 1s pause after cavput's to hopefully improve reliability.
#
# Revision 1.37  2002/06/18 17:11:49  borland
# Now sets devices to user mode before restore values from SCR file.
#
# Revision 1.36  2002/06/18 16:54:31  borland
# Fixed bug in last change.
#
# Revision 1.35  2002/06/18 16:53:46  borland
# Fixed bug in last change.
#
# Revision 1.34  2002/06/18 16:52:42  borland
# Can now return gaps to setpoints or to return values.
#
# Revision 1.33  2002/06/18 16:42:44  borland
# Fixed bug in last chagne.
#
# Revision 1.32  2002/06/18 16:40:42  borland
# APSMpIDRestoreUserGaps now optionally moves the gaps.
#
# Revision 1.31  2002/06/18 16:36:54  borland
# Improved description text.
#
# Revision 1.30  2002/06/18 15:48:29  borland
# Added routine to restore ID settings from an SCR file.  Fixed some other
# bugs.  This version basically works.
#
# Revision 1.29  2002/06/18 15:24:08  borland
# Fixed various bugs.  No longer use global access control.
#
# Revision 1.28  2002/06/18 15:01:51  borland
# Fixed bug in last change.
#
# Revision 1.27  2002/06/18 15:00:10  borland
# Set access to user mode before setting return values.
#
# Revision 1.26  2002/06/18 14:37:41  borland
# Fixed a bug in switch to user mode.
#
# Revision 1.25  2002/06/18 14:01:02  borland
# Added APSMpIDTransferSettingsToReturnValues, APSMpIDSwitchToUserMode,
# and APSMpIDSwitchToMachinePhysicsMode, plus InitDialog and Info routines.
# Not fully tested.
#
# Revision 1.24  2002/03/15 17:39:34  emery
# Replaced based directory from /home/helios/oagData/sr/BPLDs
# to /home/helios/oagData/sr/IDs
#
# Revision 1.23  1998/08/09 03:11:34  emery
# Added test to ignore negative readings of gap readback.
#
# Revision 1.22  1998/07/06 22:35:56  borland
# Minor change in error messages.
#
# Revision 1.21  1998/05/25 22:50:29  borland
# Fixed problem with GoAndWait routines that cropped up when the setpoint
# is changed while the procedures run.
#
# Revision 1.20  1998/05/25 22:42:49  borland
# APSIDGoAndWait and APSIDsGoAndWait now support ID=<n>us or <n>ds.
#
# Revision 1.19  1998/05/25 22:37:40  borland
# Fixed bug in APSIDsGoAndWait.
#
# Revision 1.18  1998/05/25 22:35:16  borland
# Added APSIDsGoAndWait
#
# Revision 1.17  1998/01/03 22:17:22  borland
# Updated with new XFD PV names.
#
# Revision 1.16  1997/07/25 18:44:13  borland
# Modified APSMpOpenAllGaps to decide on an individual basis for each ID,
# rather than opening them all if any ID needs it.
#
# Revision 1.15  1997/07/25 18:36:06  borland
# New version of APSMpOpenAllGaps, which checks access mode, gap values,
# and gap motion before issuing open command.
#
# Revision 1.14  1997/07/24 14:59:49  emery
# Added AM sources as option to APSGetSourcePointSectors procedure.
#
# Revision 1.13  1997/07/17 07:03:33  emery
# Added a test in APSIDMinimumActualGap to test that
# warning messages that is returned from cavget isn't used
# to scan for an IDNumber value.
#
# Revision 1.12  1997/05/28 00:16:40  borland
# Fixed names in return messages from APSIDGoAndWait
#
# Revision 1.11  1997/05/20 21:10:45  borland
# Made mostly cosmetic changes to gap access control stuff.  Still untested.
#
# Revision 1.10  1997/04/28 15:28:06  borland
# Added procedure to control ID gap access.
#
# Revision 1.9  1997/04/07 01:36:14  borland
# Reduced some pendIO ties.
#
# Revision 1.8  1997/04/03 23:11:19  borland
# Added us controls to open and restore gap procedures.
#
# Revision 1.7  1997/04/02 18:43:40  borland
# APSIDMinimumActualGap checks for 'us' ID PVs now.
#
# Revision 1.6  1997/03/28 21:05:14  borland
# Added routine to return BM source point sectors.  Both ID and BM
# routines handled by a common routine.
#
# Revision 1.5  1997/03/26 22:33:54  borland
# Added functions for closing/opening all IDs.  Not tested.
#
# Revision 1.4  1997/02/20 16:51:41  borland
# Added retries feature to deal with freezing up of ID.
#
# Revision 1.3  1997/02/20 15:39:47  borland
# Fixed syntax error in cawait command.
#
# Revision 1.2  1997/02/20 15:36:51  borland
# Fixed bad format specifier.
#
# Revision 1.1  1997/02/06 16:49:22  borland
# First version.
#
#
proc APSIDGoAndWait {args} {
    set ID 0
    set tolerance 0.05
    set timeout 10
    set retries 30
    APSStrictParseArguments {ID tolerance timeout retries}

    set suffix ""
    scan $ID %ld%s ID suffix
    set IDName [format ID%02ld%s $ID $suffix]
    set errorMessage "APSIDGoAndWait: Invalid parameters"
    if [catch {exec cavget -pend=5 -list=${IDName}:GapSet -printErrors} setGap] {
        APSMpReturn error "APSIDGoAndWait: $setGap"
    }
    set upperLimit [expr $setGap+$tolerance]
    set lowerLimit [expr $setGap-$tolerance]
    while {$retries>0} {
        if {[catch {exec cavput -pend=5 -list=${IDName}:Start=1} result] || \
              [catch {exec cawait -interval=1 -timelimit=$timeout \
                        -waitFor=${IDName}:Gap,lower=$lowerLimit,upper=$upperLimit} result]} {
            set errorMessage "APSIDGoAndWait: $result"
        } else {
            set errorMessage ""
            break
        }
        incr retries -1
    }
    if [catch {exec cavget -list=${IDName}:Gap -pend=15 -printErrors} gap] {
        APSMpReturn error "APSIDGoAndWait: $gap"
    }
    set diff [format %.3f [expr abs($setGap-$gap)]]
    if {$diff>$tolerance} {
        append errorMessage "\n$IDName: the difference between gap setpoint and readback values is $diff > tolerance=$tolerance"
    }
    if [string length $errorMessage] {
        APSMpReturn error "$errorMessage"
    }
}

proc APSIDsGoAndWait {args} {
    set IDList ""
    set tolerance 0.05
    set timeout 10
    set retries 30
    APSStrictParseArguments {IDList tolerance timeout retries}
    if [llength $IDList]==0 {
        APSMpReturn error "APSIDsGoAndWait: IDList is empty"
    }
    set errorMessage "APSIDsGoAndWait: invalid arguments"
    set IDNameList ""
    set cawaitOptions ""

# This loop doesn't seem necessary because IDNameList is exactly the same as IDList
    foreach ID $IDList {
        set suffix ""
        set ID [regsub {ID} $ID ""]
        scan $ID %ld%s ID suffix
        lappend IDNameList [format ID%02ld%s $ID $suffix] 
    }
    if [catch {exec cavget -list=[join $IDNameList ,] -list=:GapSet -pend=30 -printErrors} setGapList] {
        APSMpReturn error "APSIDsGoAndWait (1): $setGapList"
    }
    set first 1
    foreach IDName $IDNameList setGap $setGapList {
        if {$setGap=="?"} {
            APSMpReturn error "APSIDsGoAndWait (2): unable to get the value of $IDName:GapSet"
        }
        set upperLimit [expr $setGap+$tolerance]
        set lowerLimit [expr $setGap-$tolerance]
        lappend cawaitOptions -waitFor=${IDName}:Gap,lower=$lowerLimit,upper=$upperLimit
        if !$first {
            lappend cawaitOptions -and
        }
        set first 0
    }
    while {$retries>0} {
        #sometimes Stop and then Start can fixed the stalled IDs
        if [catch {exec cavput -pend=5 -list=[join $IDNameList ,] -list=:Stop=1} result] {
            set errorMessage "APSIDsGoAndWait (3a): $result"
        }
        after 1000
        if {[catch {exec cavput -pend=5 -list=[join $IDNameList ,] -list=:Start=1} result] || \
                [catch {eval exec cawait -interval=1 -timelimit=$timeout \
                            $cawaitOptions} result]} {
            set errorMessage "APSIDsGoAndWait (3): $result"
        } else {
            set errorMessage ""
            break
        }
        incr retries -1
    }
    if [catch {exec cavget -list=[join $IDNameList ,] -list=:Gap -pend=30 -printErrors} gapList] {
        APSMpReturn error "APSIDsGoAndWait (4): $gapList"
    }
    set first 1
    foreach IDName $IDNameList setGap $setGapList gap $gapList {
        if {$gap=="?"} {
            APSMpReturn error "APSIDsGoAndWait (5): unable to get the value of $IDName:Gap"
        }
        set diff [format %.3f [expr abs($setGap - $gap)]]
        if {$diff > $tolerance} {
            if {$first} {
                append errorMessage "\nThe difference between gap setpoint and readback of following IDs are greater than the tolerance($tolerance): "
            }
            append errorMessage "\n$IDName: $diff"
            set first 0
        }
    }
    if [string length $errorMessage] {
        APSMpReturn error $errorMessage
    }
}

set apsIDSectorListMtime -1
set apsIDSectorListData ""
set apsBMSectorListMtime -1
set apsBMSectorListData ""
set apsAMSectorListMtime -1
set apsAMSectorListData ""
proc APSGetSourcePointSectors {args} {
    set numberFormat %ld
    set group ID
    APSStrictParseArguments {numberFormat group}

    switch $group {
        ID {
            set dirName /home/helios/oagData/sr/IDs
            set sectorsFile $dirName/sectors.sdds
        }
        BM {
            set dirName /home/helios/oagData/sr/BMs
            set sectorsFile $dirName/sectors.sdds
        }
        AM {
            set dirName /home/helios/oagData/sr/AMs
            set sectorsFile $dirName/sectors.sdds
        }
        default {
            APSMpReturn error "APSGetSourcePointSectors: Invalid group named."
        }
    }
    global apsIDSectorListData apsIDSectorListMtime
    global apsBMSectorListData apsBMSectorListMtime
    global apsAMSectorListData apsAMSectorListMtime
    set theTime [expr int([exec timeconvert -break=now])]

    if [string compare [file type $sectorsFile] link]==0 {
        set sectorsFile [file readlink $sectorsFile]
        if [string length [file dirname $sectorsFile]]<2 {
            set sectorsFile $dirName/$sectorsFile
        }
    }
    if ![file exists $sectorsFile] {
        APSMpReturn error "Unable to return $group sector list---file not found!"
    }
    set mtime [file mtime $sectorsFile]
    if {[subst \$aps${group}SectorListMtime]<0 || $mtime>[subst \$aps${group}SectorListMtime]} {
        if [catch {exec sdds2stream -column=Sector $sectorsFile} result] {
            APSMpReturn error "Unable to return ${group} sector list: $result"
        }
        set aps${group}SectorListData $result
        set aps${group}SectorListMtime $theTime
    }
    set returnList ""
    foreach elem [subst \$aps${group}SectorListData] {
        lappend returnList [format $numberFormat $elem]
    }
    return $returnList
}

proc APSIDOpenAllGaps {} {
    if [catch {exec cavput -pendIOTime=5 -list=ID:OpenDevice=1} result] {
        APSMpReturn error "APSIDOpenAllGaps(cavput): $result"
    }
}

proc APSCheckRFPower {args} {
    if [catch {exec cavget -list=SRF: -list=K4,K3,K2,K1 -list=:ED1:Ch1KWatt -pend=20 -printErrors} valList] {
        APSMpReturn error "APSCheckRFSystem(1): $valList"
    }
    set message ""
    foreach pv {K4 K3 K2 K1} val $valList {
        if {$val>=735.0} {
            append message "$pv foward power is $val.\n"
        }
    }
    if [string length $message] {
        append message "\nThe klystron forward power is nearing the RF Group limit of 750kW."
        return $message
    }
    if [catch {exec cavget -list=SRF: -list=S40,S38,S37,S36 -list=:AveragePowerM -pend=10 -printErrors} valList] {
        APSMpReturn error "APSCheckRFSystem(2): $valList"
    }
    foreach pv {S40 S38 S37 S36} val $valList {
        if {$val>=89.0} {
            append message "$pv avecavity forward power is $val.\n"
        }
    }
    if [string length $message] {
        append message "\nThe average forward power is nearing the RF Group limit of 90kW."
    }
    return $message
}

proc APSIDStaggerGaps {args} {
    set IDList ""
    set interval 5
    set returnGaps 0
    APSParseArguments {IDList interval returnGaps}
    if ![llength $IDList] {
        APSMpReturn ok
    }
    if $returnGaps {
        set ext CloseDevice
        set gapExt GapReturn
    } else {
        set ext Start
        set gapExt GapSet
    }
   
    #Due to on-going restriction on the SR rf systems, we need the option to stagger the closing of the gaps by a selectable time interval T.
    #if N IDs are to be closed, the commands to start closing would be issued in a loop with a wait time of T, so that
    #issuing all the close commands would take (N-1)*T
    
    #special case for 2 ID, the ID2us has to be over 60mm before closing the ID2ds
    set procList ""
    set descList ""
    set index 1
    
    set IDList0 $IDList 
    set scuList {ID01ds ID06ds ID07ds}
    set IDList ""
    foreach ID $IDList0 {
        if {[lsearch -exact $scuList $ID]>=0} {
            if [catch {exec cavget -list=$ID:$gapExt -pend=20 -printErrors} value] {
                APSMpReturn error "APSIDStaggerGaps1: Error reading $ID:GapSet: $value"
            }
            set id$index [APSMpParallel -mode "Automatic" -procedure "APSSRMoveSCUID -ID $ID -moveTo $value"]
            lappend procList id$index
            lappend descList "moving $ID"
            incr index
        } elseif {$ID=="ID01us"} {
            if [catch {exec cavget -list=$ID:$gapExt -pend=20 -printErrors} value] {
                APSMpReturn error "APSIDStaggerGaps2: Error reading $ID:GapSet: $value"
            }
            set id$index [APSMpParallel -mode "Automatic" -procedure "APSSRMoveID01US -moveTo $value"]
            lappend procList id$index
            lappend descList "moving ID01us"
            incr index
        } else {
            lappend IDList $ID
        }
    }
    
    if [llength $IDList] {
        set id$index [APSMpParallel -mode "Automatic" -procedure "APSIDMoveRegularGaps -IDList \"$IDList\" -interval $interval -returnGaps $returnGaps"]
        lappend procList id$index
        lappend descList "moving other gaps."
        incr index

    }
    foreach procID $procList desc $descList {
        APSMpStep "Running $desc"
        if [catch {APSMpJoin [set $procID]} results] {
            if {[APSPEMTKDialog .warningDialog -text "Problem occured $desc: $results"]==1} {
                APSMpReturn error "APSIDStaggerGaps3: $results"
            }
        } 
    }
    APSMpReturn ok
}

proc APSIDMoveRegularGaps {args} {
    set IDList ""
    set interval 5
    set returnGaps 0
    APSParseArguments {IDList interval returnGaps}
    if ![llength $IDList] {
        APSMpReturn ok
    }
    if $returnGaps {
        set ext CloseDevice
    } else {
        set ext Start
    }
    #Due to on-going restriction on the SR rf systems, we need the option to stagger the closing of the gaps by a selectable time interval T.
    #if N IDs are to be closed, the commands to start closing would be issued in a loop with a wait time of T, so that
    #issuing all the close commands would take (N-1)*T
    foreach ID $IDList {
        if [catch {APSCheckRFPower} result] {
            APSMpReturn error "APSIDtaggerGaps(1b)- Error in checking RF power: $result"
        }
        if [string length $result] {
            set answer [APSMultipleChoice .info -modal 1 -name "SR RF power checking failed" \
                          -question "${result}\nDo you wish to continue or abort this procedure?" \
                          -labelList {Continue-at-your-own-risk Abort} \
                          -returnList {Continue Abort} ]
            if {$answer=="Abort"} {
                APSMpReturn error "APSIDtaggerGaps(1b): aborted because:\n$result"
            }
        }
        if !$returnGaps {
            if [catch {exec cavget -list=$ID -list=:Gap,:GapSet -printErrors} valList] {
                set answer [APSMultipleChoice .warning -modal 1 -name "Reading gap/gapset values failed" \
                              -question "$valList\nDo you wish to continue or abort?" \
                              -labelList {Continue-at-your-own-risk Abort} \
                              -returnList {Continue Abort}]
                if {$answer=="Abort"} {
                    APSMpReturn error "APSIDStaggerGaps(1): $valList"
                }
            }
            set gap [lindex $valList 0]
            set setgap [lindex $valList 1]
            if {[expr abs($gap-$setgap)]<=0.05} {
                continue
            }
        }
        if [catch {exec cavput -list=${ID}:${ext}=1} result] {
            set answer [APSMultipleChoice .warning -modal 1 -name "start moving gap failed" \
                          -question "move $ID gap failed:$result\nDo you wish to continue or abort?" \
                          -labelList {Continue-at-your-own-risk Abort} \
                          -returnList {Continue Abort}]
            if {$answer=="Abort"} {
                APSMpReturn error "APSIDStaggerGaps(2): $result"
            }
        }
        APSWaitWithUpdate -waitSeconds $interval -updateInterval 1
    }
    APSMpReturn ok
}

proc APSIDReturnAllGaps {} {
    if [catch {exec cavput -pendIOTime=5 -list=ID:CloseDevice=1} result] {
        APSMpReturn error "APSIDReturnAllGaps: $result"
    }
}

proc APSIDGetBadDeviceList {args} {
    if [catch {exec sddsprocess /home/helios/oagData/sr/IDs/devices.sdds -pipe=out \
		   -edit=col,ControlName,DeviceName,ei/:MotorDriveStatus/ \
		   | sddscasr -pipe -save -pend=20 \
		   | sddsprocess -pipe -nowarnings -match=col,CAError=n \
		   -scan=col,Value,ValueString,%lf \
		   -filter=col,Value,-0.5,0.5 \
		   | sdds2stream -pipe -col=DeviceName} dataList] {
	APSMpReturn error "APSIDGetDeviceList: $dataList"
    }
    return [join $dataList]
}

proc APSIDGetDeviceList {args} {
    set full 1 
    APSParseArguments {full}
    if $full {
        set dataList [exec sdds2stream /home/helios/oagData/sr/IDs/devices.sdds -col=DeviceName]
    } else {
        if [catch {exec sddsprocess /home/helios/oagData/sr/IDs/devices.sdds -pipe=out \
                       -edit=col,ControlName,DeviceName,ei/:MotorDriveStatus/ \
                       | sddscasr -pipe -save -pend=20 \
                       | sddsprocess -pipe -nowarnings -match=col,CAError=n \
                       -scan=col,Value,ValueString,%lf \
                       -filter=col,Value,0.5,1.5 \
                       | sdds2stream -pipe -col=DeviceName} dataList] {
            APSMpReturn error "APSIDGetDeviceList: $dataList"
        }
    }
    foreach item $dataList {
        lappend returnList [string trim $item]
    }
    return $returnList
}

proc APSIDGetTaperDeviceList {args} {
    set full 1
    APSParseArguments {full} 
    if $full {
        if [catch {exec sddsprocess /home/helios/oagData/sr/IDs/devices.sdds \
                     -pipe=out -filter=col,Taper,0.5,1.5 \
                     | sdds2stream -pipe -col=DeviceName } deviceList] {
            APSMpReturn error "APSIDGetTaperDeviceList: $deviceList"
        }
    } else {
        if [catch {exec sddsprocess /home/helios/oagData/sr/IDs/devices.sdds -pipe=out \
                     -edit=col,ControlName,DeviceName,ei/:MotorDriveStatus/ \
                     -filter=col,Taper,0.5,1.5 \
                     |  sddscasr -pipe -save -pend=60 \
                     | sddsprocess -pipe -nowarnings \
                     -scan=col,Value,ValueString,%lf \
                     -filter=col,Value,0.5,1.5 \
                     | sdds2stream -pipe -column=DeviceName} deviceList] {
            APSMpReturn error "$deviceList"
        }
    }
    foreach item $deviceList {
        lappend returnList [string trim $item]
    }
    return $returnList
}


proc APSIDMinimumActualGap {} {
    set deviceList [APSIDGetDeviceList]
    if [catch {exec cavget -label -list=[join $deviceList ,] -list=:Gap -printErrors} gapList] {
        APSMpReturn error "APSIDMiniumActualGap: $gapList"
    }
    array set gapArray $gapList
    set minimum 1000
    set checked 0
    set PVName ""
    foreach elem [array names gapArray] {
        if {[string compare $gapArray($elem) ?] && 
            1==[scan $elem "ID%02ld" IDNumber] } {
            incr checked
            # negative values of gap are false readings and should be ignored
            if {[expr $gapArray($elem) > 0] && 
                [expr $gapArray($elem)<$minimum]} {
                set minimum $gapArray($elem)
                set PVName $elem
            }
        }
    }
    if !$checked {
        APSMpReturn error "APSIDMiniumActualGap: No gaps returned."
    }
    scan $PVName "ID%02ld" IDNumber
    return [list $minimum $IDNumber]
}

proc APSIDSectorList {args} {
    return [eval APSGetSourcePointSectors $args -group ID]
}

proc APSBMSectorList {args} {
    return [eval APSGetSourcePointSectors $args -group BM]
}

# Changes gap access mode.  Returns previous mode list.
proc APSIDControlGapAccess {args} {
    # newModes is a string of the form <pvName>=<value>[,<pvName>=<value>...]
    set newModes ""
    # newMode is either User or Operator
    set newMode ""
    set readOnly 1
    APSStrictParseArguments {newModes newMode readOnly}

    if {!$readOnly} {
        if {[string length $newModes] && [string length $newMode]} {
            APSMpReturn error \
              "APSIDControlGapAccess: give either -newModes or -newMode, not both."
        }
        if {[string length $newMode] && \
              [lsearch {User Operator} $newMode]==-1} {
        APSMpReturn error "APSIDControlGapAccess: -newMode invalid: $newMode"
        }
    }

    # get present ID security modes plus a list to use
    # for setting modes from the -newMode option, if given
    set deviceList [APSIDGetDeviceList]
    if [catch {exec cavget -pend=5 -label -list=[join $deviceList ,] \
                 -list=:AccessSecurity -printErrors} accessList] {
        APSMpReturn error "APSIDControlGapAccess: $accessList"
    }
    set previousModeList ""
    set newModeList ""
    set indexLimit [llength $accessList]
    for {set index 0} {$index<$indexLimit} {incr index 2} {
        set value [lindex $accessList [expr $index+1]]
        if [string compare $value ?] {
            lappend previousModeList [lindex $accessList $index]=$value
            lappend newModeList [lindex $accessList $index]=$newMode
        }
    }
    if $readOnly {
        return [join $previousModeList ,]
    }

    if [string length $newModes] {
        if [catch {exec cavput -list=$newModes -pend=5} result] {
            APSMpReturn error "APSIDControlGapAccess: $result"
        }
    } else {
        if [catch {exec cavput -list=[join $newModeList ,] -pend=5} result] {
            APSMpReturn error "APSIDControlGapAccess: $result"
        }
    }
    return [join $previousModeList ,]
}

proc APSMpIDSwitchToMachinePhysicsModeInfo {} {
    return "Switch *all* IDs to machine physics mode, with optional opening of the gaps.  Intended to be run at the end of a user period."
}

proc APSMpIDSwitchToMachinePhysicsModeInitDialog {frame} {
    global APSMpIDSwitchToMachinePhysicsMode
    set APSMpIDSwitchToMachinePhysicsMode(openGaps) 0
    set APSMpIDSwitchToMachinePhysicsMode(restoreXbpmRefGaps) 1
    set APSMpIDSwitchToMachinePhysicsMode(closeInterval) 3
    label $frame.label -relief ridge -text "Warning!" -bg red -fg white
    pack $frame.label -side top -fill x
    message $frame.msg -relief ridge -justify center -bd 2 \
      -width 500 -text "You are about to switch all IDs to machine physics mode.\nBe certain this is what you want to do!\n"
    pack $frame.msg -side top -fill both -expand 1

    APSRadioButtonFrame .open -parent $frame -orientation horizontal \
      -variable APSMpIDSwitchToMachinePhysicsMode(openGaps) \
      -label "Open gaps?" \
      -buttonList "Yes No" -valueList "1 0" \
      -commandList {"set APSMpIDSwitchToMachinePhysicsMode(restoreXbpmRefGaps) 0" ""} \
      -contextHelp "Select whether or not to open the ID gaps.  User return values will be saved in any event."
    APSRadioButtonFrame .xref -parent $frame -orientation horizontal \
      -variable APSMpIDSwitchToMachinePhysicsMode(restoreXbpmRefGaps) \
      -commandList {"set APSMpIDSwitchToMachinePhysicsMode(openGaps) 0" ""} \
      -label "Restore xray bpm reference gaps?" \
      -buttonList "Yes No" -valueList "1 0" \
      -contextHelp "Select whether or not to restore xray bpm reference gaps."
    APSLabeledEntry .interval -parent $frame -textVariable APSMpIDSwitchToMachinePhysicsMode(closeInterval) \
      -label "Interval of closing gaps (seconds):" -width 20 \
      -contextHelp "Due to on-going restrictions on the SR rf systems, we need to tagger the closing of the gaps by a selectable time interval, i.e. issuing the next gap close command after T seconds of the previous one."
}

proc APSMpIDSwitchToMachinePhysicsMode {args} {
    set openGaps 0
    set restoreXbpmRefGaps 0
    set closeInterval 3
    APSStrictParseArguments {openGaps restoreXbpmRefGaps closeInteral}

    APSMpStep init -promptDialog APSMpIDSwitchToMachinePhysicsModeInitDialog \
      -vars "openGaps restoreXbpmRefGaps closeInterval"

    if {$openGaps && $restoreXbpmRefGaps} {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode: open gaps and restore xray bpm reference gaps should  not be done at the same time."
    }
    tk_dialog2 .dialog "Warning" "Warning: This procedure takes about several minutes, please be patient." warning -1 OK
    foreach par {openGaps restoreXbpmRefGaps} {
        append paramString "$par=\"[set $par]\" "
    }
    catch {APSLogScriptAction \
               -procedure  APSMpIDSwitchToMachinePhysicsMode \
               -action initialize \
               -state ok \
               -parameters $paramString \
           }
    # Get a list of all the installed devices.
    set deviceList [APSIDGetDeviceList]
    set taperList [APSIDGetTaperDeviceList]
    #save snapshots before switching to machine physics mode"
    if [catch {exec cavget -list=ID01us:Gap -pend=30} usGap] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(1a: error reading ID01ds gap): $usGap"
    }
    set oldDir [pwd]
    cd /home/helios/oagData/sr/IDs
    catch { exec rm SetGapTo60mm
        exec rm XbpmRefGaps }
    if {$usGap<170} {
       # APSMpStep "switch SetGapTo60mm and XbpmRefGaps to ID01us"
        exec ln -s SetGapTo60mm.ID01us SetGapTo60mm
        exec ln -s XbpmRefGaps.ID01us XbpmRefGaps
    } else {
        #APSMpStep "switch SetGapTo60mm and XbpmRefGaps to ID01ds"
        exec ln -s SetGapTo60mm.ID01ds SetGapTo60mm
        exec ln -s XbpmRefGaps.ID01ds XbpmRefGaps
    }
    cd $oldDir
    APSMpStep "Routine SCR Save before switching to machine physics mode."
    if [catch {APSSaveMachine -machine SR \
                 -description "Routine save: User gap setpoints before studies."} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(1 - SR user gap setpoints save before studies): $result"
    }
    APSMpStep "XrayBPM Save before switching to machine physics mode"
    if [catch {APSSaveMachine -machine SRXrayBPM \
                 -description "XrayBPM Save before switching to machine physics mode."} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(2 - SRXrayBPM save): $result"
    }
    
    if $openGaps {
        APSMpStep "Open gaps"
        if [catch {APSIDOpenAllGaps} result] {
            APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(4 - OpenAllGaps): $result"
        }
        after 60000

        APSMpStep "Change access mode"
        #changed to use global command for changing the access mode
        if [catch {exec cavput "-list=ID:AccessSecurity=Machine Physics" -pend=20} result] {
            if [catch {exec caput ID:AccessSecurity 2} result] {
                APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(5 - exec caput ID:AccessSecurity 2): $result"
            }
        }
        after 1000
        tk_dialog2 .dialog "DONE" "Click OK if gaps stop moving and gap accesses are switched to machine physics mode!" \
          warning -1 OK
        #turn off  abort kicker
        if [catch {exec cavput -list=S:AK0:VoltageSetSendAO=0 -pend=30} result] {
            APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(5a: Error turning off abort kicker: $result"
        }
        APSMpReturn ok
    }
    
    # If we make it here then the gaps are not to be opened.

    # Figure out which devices connect and what their access security state is.
    if [catch {exec cavget -pend=5 -printErrors -list=[join $deviceList ,] \
                 -list=:AccessSecurity -num} accessValueList] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(6 - cavget): $accessList"
    }
    set problemList ""
    set userModeList ""
    set managerModeList ""
    foreach device $deviceList accessValue $accessValueList {
        if [string compare $accessValue ?]==0 {
            lappend problemList $device
        } elseif {$accessValue==3} {
            lappend managerModeList $device
        } else {
            lappend userModeList $device
            if [lsearch -exact $taperList $device]!=-1 {
                lappend userModeTaperList $device
            }
        }
    }
    
    if [llength $problemList] {
        # Allow user to abort if there are CA problems
        APSMpStep "Problem with CA for some devices"
        set abort [APSMultipleChoice [APSUniqueName .] -modal 1 \
                     -question "Problems with channel access for these devices:\n[join $problemList ,]\nWhat do you want to do?" \
                     -labelList "Abort Continue" \
                     -returnList "1 0"]
        if $abort {
            APSMpStep "Problem with CA---aborted by user" 
            APSMpReturn ok "Aborted by user request"
        }
    }
    if [llength $userModeList]==0 {
        APSMpReturn error "All devices are in manager mode"
    }
    
    set gaptolerance 0.1
    set tapertolerance 0.1
    APSMpStep "Get user gap values"
    if [catch {exec cavget -list=[join $userModeList ,] -list=:GapSet -printErrors -pend=10} gapSetList] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(7 - cavget): $gapSetList"
    }
    if [catch {exec cavget -list=[join $userModeList ,] -list=:Gap -printErrors -pend=10} gapList] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(8 - cavget): $gapSetList"
    }
    set diffList ""
    foreach gap $gapList gapset $gapSetList pv $userModeList {
        set diff [expr abs($gap - $gapset)]
        if {$diff>$gaptolerance} {
            lappend diffList "[format %8s $pv]    $diff"
        }
    }
    if [llength $diffList] {
        APSAlertBox .warning -errorMessage "The difference of gap setpoint and readback values of following IDs are bigger than $gaptolerance:\n[format %8s ID]    difference\n[join $diffList \n]"
    }
    APSMpStep "Get user taper values"
    if [catch {exec cavget -list=[join $userModeTaperList ,] -list=:TaperGapSet -pend=10 -printErrors} taperSetList] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(9 - cavget): $taperSetList"
    }
    if [catch {exec cavget -list=[join $userModeTaperList ,] -list=:TaperGap -pend=10 -printErrors} taperList] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(10 - cavget): $taperSetList"
    }
    set diffList ""
    foreach taper $taperList taperset $taperSetList pv $userModeTaperList {
        
        set diff [expr abs($taper - $taperset)]
        if {$diff>$tapertolerance} {
            lappend diffList "[format %8s $pv]    $diff"
        }
    }
    if [llength $diffList] {
        APSAlertBox .warning -errorMessage "The difference of taper setpoint and current taper values of following IDs are bigger than $tapertolerance:\n[format %8s ID]    difference\n[join $diffList \n]"
    }
    APSMpStep "Send user gap and taper values to return PVs"
    set list1 ""
    set list2 ""
    foreach device $userModeList gap $gapSetList {
        lappend list1 $device=$gap
    }
    foreach device $userModeTaperList taper $taperSetList {
        lappend list2 $device=$taper
    }
    if [catch {exec cavput -list=[join $list1 ,] -list=:GapReturn
        exec cavput -list=[join $list2 ,] -list=:TaperGapReturn} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(11 - cavput): $result"
    }
    #for SCU1 and SCU0 do current return
    if [catch {APSSetSCUCurrentReturnValues } result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(11a Error in setting SCU current returns): $result"
    }
    after 1000

    APSMpStep "Set saved access mode to User"
    if [catch {exec cavput -list=[join $userModeList ,] -list=:SaveAccess=User} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(12 - cavput): $result"
    }
    after 1000

    APSMpStep "Set global access security mode to Machine Physics"
    if [catch {exec cavput -list=[join $deviceList ,] \
                 "-list=:AccessSecurity=Machine Physics"} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(13 - cavput): $result"
    }
    after 1000
    #do it for ID06ds (SCU0) specially
    foreach specialID {ID01ds ID06ds} {
        if [catch {exec cavget -list=$specialID:AccessSecurity -pend=30} idMode] {
            APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(13a) Error reading $specialID:AccessSecurity : idMode"
        }
        if {$idMode=="User"} {
            if [catch {exec cavput -list=$specialID:SaveAccess=User} result] {
                APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(13b - error setting $specialID:SaveAccess): $result"
            }
            after 1000
            if [catch {exec cavput "-list=$specialID:AccessSecurity=Machine Physics" -pend=30} result] {
                APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(13c) Error setting $specialID:AccessSecurity : $result"
            }
        }
    }
    APSMpStep "Set flags to inhibit saving user return gaps"
    if [catch {exec cavput -list=[join $deviceList ,] -list=:OpenFlag=1} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(14 - cavput): $result"
    }
    
    after 10000
    APSMpStep "Routine SCR Save after switching to machine physics mode."
    if [catch {APSSaveMachine -machine SR \
                 -description "Routine save: User gap setpoints after switch to studies."} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(15 - SR save): $result"
    }

    if $restoreXbpmRefGaps {
        APSMpStep "Restore xbpm reference gaps. (it may take several minutes, please be patient)."
        #set switchToMachinePhysics to zero because it is already in machine physics mode now
        if [catch {APSCloseID35Shutter} result] {
            APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(15a): error in closing ID35 shutter: $result"
        }
        
        if [catch {APSMpIDRestoreGaps -gapfile XbpmRefGaps -wait 1 -confirm 0 -switchToMachinePhysics 0 -closeInterval $closeInterval} result] {
            set abort [APSMultipleChoice [APSUniqueName .] -modal 1 -question "Problem during restore xbpm reference gaps:\n $result\nWhat do you want to do?" \
                           -labelList "Abort Continue" \
                         -returnList "1 0"]            
            if $abort {
                APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(16): problem with restore xbpm gaps): $result"
            }
        }
        APSMpStep "Routine SRXrayBPM Save after switching to machine physics mode and restoring xbpm reference gaps."
        if [catch {APSSaveMachine -machine SRXrayBPM \
                     -description "15mm Gaps."} result] {
            APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(17 - SRXrayBPM save): $result"
        }
        APSMpStep "Routine SR Save after switching to machine physics mode and restoring xbpm reference gaps."
        if [catch {APSSaveMachine -machine SR \
                     -description "15mm Gaps."} result] {
            APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(18 - SR save): $result"
        }
    }
    if [catch {exec cavput -list=ID06ds:Main_OnOff=Off -pend=30} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(19: Error turning off SCU0: $result"
    }
    APSMpStep "Please wait wile ID06ds:MainCoilCurrent (SCU0) ramps down and device shuts off"
    if [catch {exec cawait  -interval=1 -timelimit=50 -waitFor=ID06ds:MainOn,equal=0 } result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(20: error waiting for SCU0 to turn off: $result"
    }
   # APSWaitWithUpdate -waitSeconds 50 -update 1
    APSMpStep "set S:AK0:VoltageSetSendAO to 0."
    if [catch {exec cavput -list=S:AK0:VoltageSetSendAO=0 -pend=30} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(20: Error turning off abort kicker: $result"
    }
    APSMpReturn ok
}

proc APSMpIDTransferSettingsToReturnValuesInfo {} {
    return "Transfers the present values of ID gap and taper to the user's return values.  This means that when the gap close command is issued, the gap will go to these values.  You will have the opportunity to choose individual IDs on which to perform this action."
}

proc APSMpIDTransferSettingsToReturnValuesInitDialog {frame} {
    global APSMpIDTransferSettingsToReturnValues
    set deviceList0 [lsort [array names APSMpIDTransferSettingsToReturnValues]]
    foreach item $deviceList0 {
        if [string match ID* $item] {
            lappend deviceList $item
            lappend variableList APSMpIDTransferSettingsToReturnValues($item)
        }
    }
    
    APSCheckButtonFrame .cb -parent $frame -label "Choose IDs" \
      -limitPerRow 8 -buttonList "$deviceList" \
      -variableList "$variableList" -orientation horizontal -allNone 1 
}

proc APSMpIDTransferSettingsToReturnValues {args} {
    # transfer gap and taper setpoints to return values
    set fullDeviceList [APSIDGetDeviceList]
    set deviceList $fullDeviceList
    APSStrictParseArguments {deviceList}

    foreach item $fullDeviceList {
        if [lsearch -exact $deviceList $item]!=-1 {
            set $item 1
        } else {
            set $item 0
        }
    }

    APSMpStep init -promptDialog APSMpIDTransferSettingsToReturnValuesInitDialog \
      -vars "$fullDeviceList"
   
    foreach par $fullDeviceList {
        append paramString "$par=\"[set $par]\" "
    }
     catch {APSLogScriptAction \
               -procedure   APSMpIDTransferSettingsToReturnValues  \
               -action initialize \
               -state ok \
               -parameters $paramString \
           }
      
    set deviceList ""
    foreach item $fullDeviceList {
        if [set $item] {
            lappend deviceList $item
        }
    }
    if ![llength $deviceList] {
        APSMpStep "No devices selected"
        APsMpReturn ok
    }

    APSMpStep "Devices selected: $deviceList"

    APSMpStep "Get present gap values"
    if [catch {exec cavget -list=[join $deviceList ,] -list=:GapSet -pend=10 -printErrors} gapSetList] {
        APSMpReturn error "APSMpIDTransferSettingsToReturnValues: $gapSetList"
    }

    APSMpStep "Get present taper values"
    set taperFullDeviceList [APSIDGetTaperDeviceList]
    set taperDeviceList ""
    foreach device $taperFullDeviceList {
        if [lsearch -exact $deviceList $device]!=-1 {
            lappend taperDeviceList $device
        }
    }
    if [catch {exec cavget -list=[join $taperDeviceList ,] -list=:TaperGapSet -pend=10 -printErrors} taperSetList] {
        APSMpReturn error "APSMpIDTransferSettingsToReturnValues: $taperSetList"
    }
    foreach device $deviceList gap $gapSetList {
        lappend returnList $device:GapReturn=$gap
    }
    foreach device $taperDeviceList taper $taperSetList {
        lappend returnList $device:TaperGapReturn=$taper
    }
    APSMpStep "Set access to user mode"
    if [catch {exec cavput -list=[join $deviceList ,] -list=:AccessSecurity=User} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode: $result"
    }
    after 1000

    APSMpStep "Send values to return values"
    if [catch {exec cavput -list=[join $returnList ,]} result] {
        APSMpReturn error "APSMpIDTransferSettingsToReturnValues: $result"
    }
    after 1000
    #for SCU1 and SCU0 do current return
    if [catch {APSSetSCUCurrentReturnValues } result] {
        APSMpReturn error "APSMpIDTransferSettingsToReturnValues (Error in setting SCU current returns): $result"
    }
    APSMpReturn ok
}

proc APSSetSCUCurrentReturnValues {args} {
    if [catch {exec cavget -list=ID01ds,ID06ds -list=:MainCurrentSet -pend=20} result] {
        return -code error "APSSetSCUCurrentReturnValues (Error reading SCU1 and SCU0 current set): $result"
    }
    set ID01dsCurr [lindex $result 0]
    set ID06dsCurr [lindex $result 1]
    if [catch {exec cavput -list=ID01ds:CurrentReturn=$ID01dsCurr,ID06ds:CurrentReturn=$ID06dsCurr -pend=30} result] {
        return -code error "APSSetSCUCurrentReturnValues (Error set SCU1 and SCU0 current return): $result"
    }
}

proc APSMpIDSwitchToUserModeInfo {} {
    return "Switch *all* IDs to user mode, with optionally returning of the gaps.  This is normally used just before returning the machine to user mode."
}

proc APSMpIDSwitchToUserModeInitDialog {frame} {
    global APSMpIDSwitchToUserMode
    set APSMpIDSwitchToUserMode(returnGaps) 1
    set APSMpIDSwitchToUserMode(closeInterval) 1
    set APSMpIDSwitchToUserMode(setupCerenkov) 1
    label $frame.label -relief ridge -text "Warning!" -bg red -fg white
    pack $frame.label -side top -fill x
    message $frame.msg -relief ridge -justify center -bd 2 \
      -width 500 -text "You are about to switch all IDs to user mode.\nBe certain this is what you want to do!\n"
    pack $frame.msg -side top -fill both -expand 1

    APSRadioButtonFrame .open -parent $frame -orientation horizontal \
      -variable APSMpIDSwitchToUserMode(returnGaps) \
      -label "Return gaps?" \
      -buttonList "Yes No" -valueList "1 0" \
      -contextHelp "Select whether or not to return the ID gaps."
    APSRadioButtonFrame .ceren -parent $frame -orientation horizontal \
      -variable APSMpIDSwitchToUserMode(setupCerenkov) -label "Setup Cerenkov detector?"  \
      -buttonList "Yes No" -valueList "1 0" \
      -contextHelp "Select whether or not to setup Cerenkov detectors."
    APSLabeledEntry .interval -parent $frame -textVariable APSMpIDSwitchToUserMode(closeInterval) \
      -label "Interval of closing gaps (seconds):" -width 20 \
      -contextHelp "Due to on-going restrictions on the SR rf systems, we need to tagger the closing of the gaps by a selectable time interval, i.e. issuing the next gap close command after T seconds of the previous one."
}

proc APSMpIDSwitchToUserMode {args} {
    set returnGaps 1
    set closeInterval 3
    set setupCerenkov 1
    APSStrictParseArguments {returnGaps closeInterval setupCerenkov}

    APSMpStep init -promptDialog APSMpIDSwitchToUserModeInitDialog \
      -vars {returnGaps closeInterval setupCerenkov}
    set deviceList [APSIDGetDeviceList]
   
    catch {APSLogScriptAction \
               -procedure  APSMpIDSwitchToUserMode \
               -action initialize \
               -state ok \
               -parameters "returnGaps=$returnGaps" \
           }
    #save snapshots before switching to user mode"
    APSMpStep "Routine SCR Save before switching to user mode."
    if [catch {APSSaveMachine -machine SR \
                   -description "Routine save: gap setpoints before switching to user mode."} result] {
        APSMpReturn error "APSMpIDSwitchToUserMode(1 - SR routine save): $result"
    }
    APSMpStep "XrayBPM Save before switching to user mode"
    if [catch {APSSaveMachine -machine SRXrayBPM \
                 -description "XrayBPM Save before switching to user mode."} result] {
        APSMpReturn error "APSMpIDSwitchToUserMode(2 - SRXrayBPM save): $result"
    }
    APSMpStep "Change access mode"
    #set to machine physics and then set to user mode latter so that the global close can take effect.
    if [catch {exec cavput -list=ID:AccessSecurity=2 -pend=20} result] { 
        if [catch {exec caput ID:AccessSecurity 2 } result] {
            APSMpReturn error "APSMpIDSwitchToUserMode(3 - exec caput ID:AccessSecurity 2): $result"
        }
    }
    after 1000
    
    if [catch {exec cavput -list=ID:AccessSecurity=User -pend=20} result] {
        if [catch {exec caput ID:AccessSecurity 0 } result] {
            APSMpReturn error "APSMpIDSwitchToUserMode(4 - exec caput ID:AccessSecurity 0): $result"
        }
    }
    #turn on abort kicker
    if [catch {exec cavput -list=S:AK0:VoltageSetSendAO=8.3 -pend=30} result] {
        APSMpReturn error "APSMpIDSwitchToUserMode(4a): Error turning on abort kicker: $result"
    }
    #add switching SCU0 and SCU1 to user mode, like ID29
    if [catch {exec cavput -list=ID29,ID01ds,ID06ds -list=:AccessSecurity=User -pend=20} result] {
         if [catch {exec cavput -list=ID29,ID01ds,ID06ds -list=:AccessSecurity=0 -pend=20 } result] {
            APSMpReturn error "APSMpIDSwitchToUserMode(4b - exec caput ID29, ID01ds, ID06dsAccessSecurity 0): $result"
        }
    }
    after 1000

    if $returnGaps {
        APSMpStep "Return gaps"
        #if [catch {exec cavput -list=ID:CloseDevice=1} result] {
        #    APSMpReturn error "APSMpIDSwitchToUserMode(5 - exec cavput): $result"
        #}
        set deviceList [APSIDGetDeviceList]
        #Due to on-going restriction on the SR rf systems, we need the option to stagger the closing of the gaps by a selectable time interval T.
        APSMpStep "$deviceList"
        if [catch {APSIDStaggerGaps -IDList $deviceList -interval $closeInterval -returnGaps 1} result] {
            APSMpReturn error "APSMpIDSwitchToUserMode(14a): Error in close gaps with staggering: $result"
        }
       # APSMpStep "turning on SCU1 and SCU6 on and restoring the power supply setpoint."
       # if [catch {exec cavput -list=ID01ds,ID06ds -list=:CloseDevice=1 -pend=10} result] {
       #     APSMpReturn error "APSMpIDSwitchToUserMode(14b): Error in turning on SCU0: $result"
       # }
        APSMpStep "waiting for 60 seconds..."
        after 60000
        APSAlertBox .warning -errorMessage "Waiting for gaps stop moving, click ok to continue when it is done."
      # APSMpReturn ok
    } else {
        set taperList [APSIDGetTaperDeviceList]
        set deviceList [APSIDGetDeviceList]
        set tmpfile /tmp/[APSTmpString]
        set gaptolerance 0.05
        set tapertolerance 0.015
        APSMpStep "Checking gap/taper setpoint and value difference..."
        APSAddToTmpFileList -ID 1 -fileList "$tmpfile.taper $tmpfile.gap $tmpfile.gapdiff $tmpfile.gapdiff"
        if [catch {exec cavget -list=[join $taperList ,] \
                     -list=:TaperGap.VAL -pend=30 -printErrors} taperVal ] {
            APSMpReturn error "APSMpIDSwitchToUserMode(6 - cavget): Error in getting TaperGapReturn Value: $taperVal"
        }
        if [catch {exec cavget -list=[join $taperList ,] \
                     -list=:TaperGapSet.VAL -pend=30 -printErrors} taperSet ] {
            APSMpReturn error "APSMpIDSwitchToUserMode(7 - cavget): Error in getting TaperGapSet Value: $taperSet"
        }
        if [catch {exec cavget -list=[join $deviceList ,] \
                     -list=:Gap.VAL -pend=30 -printErrors} gapVal ] {
            APSMpReturn error "APSMpIDSwitchToUserMode(8 - cavget): Error in getting Gap Value: $gapVal"
        }
        if [catch {exec cavget -list=[join $deviceList ,] \
                     -list=:GapSet.VAL -pend=30 -printErrors} gapSet ] {
            APSMpReturn error "APSMpIDSwitchToUserMode(9 - cavget): Error in getting GapSet Value: $gapSet"
        }
        if [catch {exec sddsmakedataset -pipe=out \
                     -col=DeviceName,type=string -data=[join $deviceList ,] \
                     -col=Gap,type=double -data=[join $gapVal ,] \
                     -col=GapSet,type=double -data=[join $gapSet ,] \
                     -col=ValueString,type=string -data=[join $gapSet ,] \
                     | tee $tmpfile.gap \
                     | sddsprocess -pipe \
                     "-define=col,GapDiff,Gap GapSet - abs" \
                     | sddsprocess -pipe=in $tmpfile.gapdiff \
                     "-filter=col,GapDiff,0,$gaptolerance,!" -nowarnings } result] {
            APSMpReturn error "APSMpIDSwitchToUserMode(10 - sddsmakedataset): $result"
        }
        if [catch {exec sddsmakedataset -pipe=out \
                     -col=DeviceName,type=string -data=[join $taperList ,] \
                     -col=Taper,type=double -data=[join $taperVal ,] \
                     -col=TaperSet,type=double -data=[join $taperSet ,] \
                     -col=ValueString,type=string -data=[join $taperSet ,] \
                     | tee $tmpfile.taper \
                     | sddsprocess -pipe \
                     "-define=col,TaperDiff,Taper TaperSet - abs" \
                     | sddsprocess -pipe=in $tmpfile.taperdiff \
                     "-filter=col,TaperDiff,0,$tapertolerance,!" -nowarnings } result] {
            APSMpReturn error "APSMpIDSwitchToUserMode(11 - sddsmakedataset): $result"
        }
        set gapdiffs [exec sdds2stream $tmpfile.gapdiff -rows=bare]
        set taperdiffs [exec sdds2stream $tmpfile.taperdiff -rows=bare]
        if $gapdiffs {
            set gapList [exec sdds2stream $tmpfile.gapdiff -col=DeviceName]
            set answer [APSMultipleChoice [APSUniqueName .] -modal 1 -name Warning \
                                  -question "The difference of gap setpoint and current gap values of [join $gapList ,] are bigger than $gaptolerance, Continue or abort?" \
                          -returnList {Continue Abort} -labelList {Continue Abort} ]
            
            if {$answer=="Abort"} {
                APSMpReturn error "APSMpIDSwitchToUserMode(12): Setting gap/taper values was aborted due to mis-match of gap setpoint and value!"
            }
        }
        if $taperdiffs {
            set taperList [exec sdds2stream $tmpfile.taperdiff -col=DeviceName]
            set answer [APSMultipleChoice [APSUniqueName .] -modal 1 -name Warning \
                          -question "The difference of taper setpoint and current taper values of [join $taperList ,] are bigger than $tapertolerance, Continue or abort?"\
                          -returnList {Continue Abort} -labelList {Continue Abort}]
            
            if {$answer=="Abort"} {
                APSMpReturn error "APSMpIDSwitchToUserMode(13): Setting gap/taper return values was aborted due to mis-match of taper setpoint and value!"
            }
        }
        APSMpStep "Setting gap/taper return values to gap/taper values"
        if [catch {exec sddsprocess $tmpfile.gap \
                     -edit=col,ControlName,DeviceName,ei/:GapReturn.VAL/ \
                     -pipe=out \
                     | sddscasr -restore -pipe=in 
            exec sddsprocess $tmpfile.taper \
                     -edit=col,ControlName,DeviceName,ei/:TaperGapReturn.VAL/ \
                     -pipe=out \
                     | sddscasr -restore -pipe=in } result] {
            APSMpReturn error "APSMpIDSwitchToUserMode(14 - sddscasr): Error in setting GapReturn and TaperGapReturn: $result"
        }
        #2, issue a global close ("Return") command
        #if [catch {exec cavput -pendIOTime=10 -list=ID:CloseDevice=1} result] {
         #   APSMpReturn error "APSMpIDSwitchToUserMode(15 - exec cavput): APSIDReturnAllGaps: $result"
        #}
        #Due to on-going restriction on the SR rf systems, we need the option to stagger the closing of the gaps by a selectable time interval T.
        #if [catch {APSIDStaggerGaps -IDList $deviceList -interval $closeInterval -returnGaps 1} result] {
        #    APSMpReturn error "APSMpIDSwitchToUserMode(14a): Error in close gaps with staggering: $result"
        #}
    }
   # after 10000
   # APSAlertBox .warning -errorMessage "Waiting for switching to user mode, click ok to continue when it is done."
   # after 10000
    #save snapshots before switching to user mode"
    APSMpStep "Routine SCR Save after switching to user mode."
    if [catch {APSSaveMachine -machine SR \
                 -description "Routine save: gap setpoints after switching to user mode."} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(16 - SR save): $result"
    }
    APSMpStep "XrayBPM Save after switching to user mode"
    if [catch {APSSaveMachine -machine SRXrayBPM \
                 -description "XrayBPM Save after switching to user mode."} result] {
        APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(17 - SRXrayBPM save): $result"
    }
    if $setupCerenkov {
        APSMpStep "Setup Cerenkov detectors."
        if [catch {APSSetupSRCerenkovDector} result] {
            APSMpReturn error "APSMpIDSwitchToMachinePhysicsMode(17a - setup Cerenkov detectors): $result"
        }
    }
    after 1000
    APSMpReturn ok
}

proc APSMpIDRestoreUserGapsInfo {} {
    return "Generally, you would use this only if you have a problem with one or more gap values.  It restores selected user gap values from an SCR file and sets the devices to user mode. Restores the gap setpoints and the user return values.  Optionally moves the gaps to the setpoints or return values."
}

proc APSMpIDRestoreUserGapsInitDialog {frame} {
    global APSMpIDRestoreUserGaps
    set APSMpIDRestoreUserGaps(closeInterval) 3
    set deviceList0 [lsort [array names APSMpIDRestoreUserGaps]]
    foreach item $deviceList0 {
        if [string match ID* $item] {
            lappend deviceList $item
            lappend variableList APSMpIDRestoreUserGaps($item)
        }
    }
    APSCheckButtonFrame .cb -parent $frame -label "Choose IDs" \
      -limitPerRow 8 -buttonList "$deviceList" \
      -variableList "$variableList" -orientation horizontal -allNone 1 
    APSRadioButtonFrame .sp -parent $frame -orientation horizontal \
      -variable APSMpIDRestoreUserGaps(gapsToSetpoints) \
      -label "Move gaps to setpoint?" \
      -buttonList "Yes No" -valueList "1 0" \
      -commandList {"set APSMpIDRestoreUserGaps(gapsToReturnValues) 0" ""} \
      -contextHelp "Select whether or not to move the ID gaps to the setpoints."
    APSRadioButtonFrame .rv -parent $frame -orientation horizontal \
      -variable APSMpIDRestoreUserGaps(gapsToReturnValues) \
      -label "Move gaps to user return value?" \
      -buttonList "Yes No" -valueList "1 0" \
      -commandList {"set APSMpIDRestoreUserGaps(gapsToSetpoints) 0" ""} \
      -contextHelp "Select whether or not to move the ID gaps to the user return value. This is supposedly where the user wanted the gap."
    APSLabeledEntry .interval -parent $frame -textVariable APSMpIDRestoreUserGaps(closeInterval) \
      -label "Interval of closing gaps (seconds):" -width 50 \
      -contextHelp "Due to on-going restrictions on the SR rf systems, we need to tagger the closing of the gaps by a selectable time interval, i.e. issuing the next gap close command after T seconds of the previous one."
    APSAddSCRDialog .scr -parent $frame -system SR -arrayName APSMpIDRestoreUserGaps \
      -defaultFile $APSMpIDRestoreUserGaps(ShortFilename)
}

proc APSMpIDRestoreUserGaps {args} {
    set fullDeviceList [APSIDGetDeviceList]
    set deviceList $fullDeviceList
    set closeInterval 3
    APSStrictParseArguments {deviceList closeInterval}

    foreach item $fullDeviceList {
        if [lsearch -exact $deviceList $item]!=-1 {
            set $item 1
        } else {
            set $item 0
        }
    }
    set gapsToSetpoints 1
    set gapsToReturnValues 0
    set ShortFilename ""

    APSMpStep init -promptDialog APSMpIDRestoreUserGapsInitDialog \
      -desc "Choose devices and SCR file" \
      -vars "$fullDeviceList ShortFilename gapsToSetpoints gapsToReturnValues closeInterval"

    if ![string length $ShortFilename] {
        APSMpReturn error "APSMpIDRestoreUserGaps: No file chosen."
    }
    set varList "$fullDeviceList ShortFilename gapsToSetpoints gapsToReturnValues"
    foreach par $varList {
        append paramString "$par=\"[set $par]\" "
    }
    catch {APSLogScriptAction \
               -procedure  APSMpIDRestoreUserGaps \
               -action initialize \
               -state ok \
               -parameters $paramString \
           }
    set fullFilename /home/helios/oagData/SCR/snapshots/SR/$ShortFilename
    if {[string length $ShortFilename] && ![file exists $fullFilename]} {
        APSMpReturn error "APSMpIDRestoreUserGaps: SCR file $ShortFilename not found"
    }
    set first 1
    set deviceList ""
    set matchOpt ""
    foreach device $fullDeviceList {
        if {[set $device]} {
            lappend deviceList $device
            if $first {
                set first 0
                set matchOpt -match=column,ControlName=$device:*
            } else {
                set matchOpt $matchOpt,ControlName=$device:*,|
            }
        }
    }
    if ![llength $deviceList] {
        APSMpStep "No devices selected"
        APsMpReturn ok
    }
    #get the mode before changing it
    if [catch {exec cavget -list=[join $deviceList ,] -list=:AccessSecurity -numerical \
                 -pend=30 -printErrors} origList] {
        APSMpReturn error "APSMpIDRestoreUserGaps: $origList"
    }
    if [catch {exec cavget -list=[join $deviceList ,] -list=:Busy -numerical \
                 -pend=30 -printErrors} busyList] {
        APSMpReturn error "APSMpIDRestoreUserGaps: $busyList"
    }
    set cavputList ""
    foreach device $deviceList val $origList busy $busyList {
        lappend cavputList ${device}:AccessSecurity=$val
    }
    APSMpStep "Set devices to user mode"
    if [catch {exec cavput -list=[join $deviceList ,] -list=:AccessSecurity=User} result] {
        APSMpReturn error "APSMpIDRestoreUserGaps: $result"
    }
    after 1000
    
    APSMpStep "Prepare device values"
    set tmpFile /tmp/[APSTmpString]
    APSAddToTempFileList $tmpFile
    if [catch {exec sddsprocess $fullFilename $tmpFile $matchOpt} result] {
        APSMpReturn error "APSMpIDRestoreUserGaps: $result"
    }
    APSMpStep "Restore device values"
    if [catch {exec sddscasr -restore $tmpFile } result] {
        APSMpReturn error "APSMpIDRestoreUserGaps: $result"
    }
    after 1000

    if $gapsToSetpoints {
        APSMpStep "Moving gaps to setpoints"
        #if [catch {exec cavput -list=[join $deviceList ,] -list=:Start=1} result] {
        #    APSMpReturn error "APSMpIDRestoreUserGaps: $result"
        #}
        if [catch {APSIDStaggerGaps -IDList $deviceList -interval $closeInterval -returnGaps 0} result] {
            APSMpReturn error "APSMpIDRestoreUserGaps: $result"
        }
        after 1000
    }
    if $gapsToReturnValues {
        APSMpStep "Moving gaps to return values"
        #if [catch {exec cavput -list=[join $deviceList ,] -list=:CloseDevice=1} result] {
        #    APSMpReturn error "APSMpIDRestoreUserGaps: $result"
        #}
        if [catch {APSIDStaggerGaps -IDList $deviceList -interval $closeInterval -returnGaps 1} result] {
            APSMpReturn error "APSMpIDRestoreUserGaps: $result"
        }
        after 1000
    }
    #check if gaps are moving
    if {$gapsToSetpoints || $gapsToReturnValues} {
        APSMpStep "Waiting for ID gaps stop moving. (it may take several minutes, please be patient.)"
        if {[catch {APSMpCheckAndWaitForIDs -deviceList $deviceList} results]} {
            if {[APSPEMTKDialog .warningDialog -text "APSMpIDRestoreUserGaps: Problem occurred while waiting restoring ID gaps\n$results"] == 1} {
                APSMpReturn error "APSMpIDRestoreGaps: $results"
            }
        }
    }
    APSMpStep "Restore the gap mode."
    if [catch {exec cavput -list=[join $cavputList ,] -pend=30} result] {
        APSMpReturn error "APSMpIDRestoreUserGaps: $result"
    }
    APSMpReturn ok
}


proc APSMpIDTimeRestoreUserGapsInfo {} {
    return "Restore selected user gap values at a specified time from the PV history file.  Sets the devices to user mode. Restores the gap setpoints and the user return values.  Optionally moves the gaps to the setpoints or return values."
}

proc APSMpIDTimeRestoreUserGapsInitDialog {frame} {
    global APSMpIDTimeRestoreUserGaps
    set deviceList0 [lsort [array names APSMpIDTimeRestoreUserGaps]]
    foreach item $deviceList0 {
        if [string match ID* $item] {
            lappend deviceList $item
            lappend variableList APSMpIDTimeRestoreUserGaps($item)
        }
    }
    set APSMpIDTimeRestoreUserGaps(closeInterval) 3
    
    APSCheckButtonFrame .cb -parent $frame -label "Choose IDs" \
      -limitPerRow 8 -buttonList "$deviceList" \
      -variableList "$variableList" -orientation horizontal -allNone 1 
    APSRadioButtonFrame .sp -parent $frame -orientation horizontal \
      -variable APSMpIDTimeRestoreUserGaps(gapsToSetpoints) \
      -label "Move gaps to setpoint?" \
      -buttonList "Yes No" -valueList "1 0" \
      -commandList {"set APSMpIDTimeRestoreUserGaps(gapsToReturnValues) 0" ""} \
      -contextHelp "Select whether or not to move the ID gaps to the setpoints."
    APSRadioButtonFrame .rv -parent $frame -orientation horizontal \
      -variable APSMpIDTimeRestoreUserGaps(gapsToReturnValues) \
      -label "Move gaps to user return value?" \
      -buttonList "Yes No" -valueList "1 0" \
      -commandList {"set APSMpIDTimeRestoreUserGaps(gapsToSetpoints) 0" ""} \
      -contextHelp "Select whether or not to move the ID gaps to the user return value. This is supposedly where the user wanted the gap."

    APSDateTimeAdjEntry .date -parent $frame \
      -yearVariable APSMpIDTimeRestoreUserGaps(year) \
      -monthVariable APSMpIDTimeRestoreUserGaps(month) \
      -dayVariable APSMpIDTimeRestoreUserGaps(day) \
      -hourVariable APSMpIDTimeRestoreUserGaps(hour) \
      -label "Date/time (year, month, day, hour): " -defaultHour 0 
    
    APSLabeledEntry .interval -parent $frame -textVariable APSMpIDTimeRestoreUserGaps(closeInterval) \
      -label "Interval of closing gaps (seconds):" -width 20 \
      -contextHelp "Due to on-going restrictions on the SR rf systems, we need to tagger the closing of the gaps by a selectable time interval, i.e. issuing the next gap close command after T seconds of the previous one."
}

proc APSMpIDTimeRestoreUserGaps {args} {
    set fullDeviceList [APSIDGetDeviceList]
    set deviceList $fullDeviceList
    set closeInterval 3
    APSStrictParseArguments {deviceList closeInterval}

    foreach item $fullDeviceList {
        if [lsearch -exact $deviceList $item]!=-1 {
            set $item 1
        } else {
            set $item 0
        }
    }
    set gapsToSetpoints 1
    set gapsToReturnValues 0
    set ShortFilename ""
    APSSetVarsFromList \
      -valueList [clock format  [clock seconds]  -format "%Y %m %d %H:%M:%S"] \
      -variableList [list year month day hour]

    APSMpStep init -promptDialog APSMpIDTimeRestoreUserGapsInitDialog \
      -desc "Choose devices and SCR file" \
      -vars "$fullDeviceList gapsToSetpoints gapsToReturnValues year month day hour closeInterval"
    if [catch {clock scan "$month/$day/$year $hour"} timeValue] {
        APsMpReturn error "APSMpIDTimeRestoreUserGaps: Problem with date/time specification: be sure to use HH:MM:SS for time"
    }
    set varList "$fullDeviceList gapsToSetpoints gapsToReturnValues year month day hour"
    foreach par $varList {
        append paramString "$par=\"[set $par]\" "
    }
    catch {APSLogScriptAction \
               -procedure  APSMpIDTimeRestoreUserGaps \
               -action initialize \
               -state ok \
               -parameters $paramString \
           }
    APSMpStep "Check device selection"
    set first 1
    set deviceList ""
    set matchOpt ""
    foreach device $fullDeviceList {
        if [set $device] {
            lappend deviceList $device
            if $first {
                set first 0
                set matchOpt -match=column,ControlName=$device:*
            } else {
                set matchOpt $matchOpt,ControlName=$device:*,|
            }
        }
    }
    if ![llength $deviceList] {
        APSMpStep "No devices selected"
        APsMpReturn ok
    }

    APSMpStep "Check for data"
    set fileFilter \
      /home/helios/oagData/logonchange/SR/[format SR-%4d-*-%02d%02d.???? $year $month $day]
    set fileList [lsort [glob -nocomplain $fileFilter]]
    if [llength $fileList]==0 {
        APsMpReturn error "APSMpIDTimeRestoreUserGaps: No file for that date"
    }

    APSMpStep "Prepare data for restore (takes a while)"
    set tmpFile /tmp/[APSTmpString]
    APSAddToTempFileList $tmpFile
    if [catch {eval exec sddscombine $fileList -pipe=out \
                 | sddsderef -pipe \
                 -column=ControlName,array=ControlName,ControlNameIndex \
                 | sddsconvert -pipe -delete=array,* -retain=col,ControlName,Time,Value \
                 | sddscombine -merge -pipe \
                 | sddsprocess -pipe -match=col,ControlName=ID* \
                 -filter=column,Time,0,$timeValue -nowarning \
                 | sddssort -pipe -col=ControlName -col=Time,incr \
                 | sddsbreak -change=ControlName -pipe \
                 | sddsprocess -pipe -clip=0,1,invert -nowarning \
                 -print=column,ValueString,%.15f,Value \
                 -print=column,ControlType,pv \
                 -print=column,Lineage,- \
                 -define=column,Count,1,type=long \
                 -print=parameter,SnapType,Absolute \
                 | sddscombine -pipe -merge \
                 | sddsprocess -pipe=in $tmpFile $matchOpt -nowarning} result] {
        APSMpReturn error "APSMpIDTimeRestoreUserGaps: $result"
    }

    APSMpStep "Set devices to user mode"
    if [catch {exec cavput -list=[join $deviceList ,] -list=:AccessSecurity=User} result] {
        APSMpReturn error "APSMpIDTimeRestoreUserGaps: $result"
    }
    after 1000

    APSMpStep "Restore device values"
    if [catch {exec sddscasr -restore $tmpFile } result] {
        APSMpReturn error "APSMpIDTimeRestoreUserGaps: $result"
    }
    after 1000

    if $gapsToSetpoints {
        APSMpStep "Moving gaps to setpoints"
        # if [catch {exec cavput -list=[join $deviceList ,] -list=:Start=1} result] {
        #     APSMpReturn error "APSMpIDTimeRestoreUserGaps: $result"
        # }
        #Due to on-going restriction on the SR rf systems, we need the option to stagger the closing of the gaps by a selectable time interval T.
        if [catch {APSIDStaggerGaps -IDList $deviceList -interval $closeInterval -returnGaps 0} result] {
            APSMpReturn error "APSMpIDTimeRestoreUserGaps: Error in close gaps with staggering: $result"
        }
        after 1000
    }
    if $gapsToReturnValues {
        APSMpStep "Moving gaps to return values"
        #if [catch {exec cavput -list=[join $deviceList ,] -list=:CloseDevice=1} result] {
        #    APSMpReturn error "APSMpIDTimeRestoreUserGaps: $result"
        #}
        if [catch {APSIDStaggerGaps -IDList $deviceList -interval $closeInterval -returnGaps 1} result] {
            APSMpReturn error "APSMpIDTimeRestoreUserGaps: Error in close gaps with staggering: $result"
        }
        after 1000
    }
    APSMpReturn ok
}

proc APSMpCPUInitializeInfo {} {
    return "Sets up the CPU with the correct DC files and AC waveform files. Also sets up the proper limits for operation.\n\nThe CPU should be at zero current when executing this command."
}


proc APSMpCPUInitialize {} {
    APSMpStep init -promptDialog "APSMpPromptInitDialog"
    # Should only initialize when the ID is at zero readback. (Setpoint of zero is 
    # not reliable since the CPU may be still be ramping to zero.)
    if [catch {exec cavget -list=ID04b: -list=H,V -list=_coil.VAL -pend=10 -printErrors \
             } readbacks] {
        APSMpReturn error "APSMpCPUInitialize: $result"
    }
    if { [expr abs([lindex $readbacks 0]) > 5] || [expr abs([lindex $readbacks 1]) > 5] } {
        # not at zero yet.
        APSAlertBox .warning -errorMessage "CPU readbacks not at zero. No action taken.\n\nTry again when CPU is at zero current."
        APSMpReturn error "APSMpCPUInitialize: Aborted because CPU readbacks are not at zero."
    }
    # Set the default files
    if [catch {exec cavput -list=ID04b:corrFile=/sr/IDs/CPU/DCmodes/default \
             } result] {
        APSMpReturn error "APSMpCPUInitialize: $result"
    }
    set ACfile(1) /sr/IDs/CPU/ACmodes/vcorr2.default
    set ACfile(2) /sr/IDs/CPU/ACmodes/hcorr2.default
    set ACfile(3) /sr/IDs/CPU/ACmodes/hcorr1.default
    set ACfile(4) /sr/IDs/CPU/ACmodes/vcorr1.default
    set ACfile(5) /sr/IDs/CPU/ACmodes/normalQuad.sdds
    set ACfile(6) /sr/IDs/CPU/ACmodes/skewOct.sdds
    set ACfile(7) /sr/IDs/CPU/ACmodes/skewQuad.sdds
    if [catch {exec cavput -list=ID04b:corrFile_ \
                 -list=1=$ACfile(1),2=$ACfile(2),3=$ACfile(3),4=$ACfile(4),5=$ACfile(5),6=$ACfile(6),7=$ACfile(7) \
             } result] {
        APSMpReturn error "APSMpCPUInitialize: $result"
    }
    # load the files
    if [catch {exec cavput -list=ID04b:loadCorr=1 \
             } result] {
        APSMpReturn error "APSMpCPUInitialize: $result"
    }
    if [catch {exec cavput -list=ID04b:loadCorr_=1 -list=1,2,3,4,5,6,7 \
             } result] {
        APSMpReturn error "APSMpCPUInitialize: $result"
    }
    
    # set some numercial PVs
    set halfPeriod 1
    if [catch {exec cavput -list=ID04b:timer.VAL=$halfPeriod \
             } result] {
        APSMpReturn error "APSMpCPUInitialize: $result"
    }
    APSMpReturn ok
}

proc APSMpResetCPUAfgInfo {args} {
    return "This procedure resets CPU afg when channels are stuck while beam is stored. It is important that the real-time feedback be running while beam is stored, otherwise the beam will be dumped by the orbit change."
}
proc APSMpResetCPUAfg {args} {
    
    APSMpStep "ResetCPUAfg - Step 0: Turn off CPU main current"
    #to make it turn off the CPU main current, 
    #switch the Trigger select to 'Internal', switch the polarization mode to 'CW/CCW'
    #Once the CPU is turned back on after AFG get reset, it returns to the default 
    #mode that matches the default state of the AFG ???
    if [catch {exec cavget -list=ID04b:set_V_coil -pend=30 -printErrors} ID4Current] {
        APSMpReturn error "APSMpResetCPUAfg: $ID4Current"
    }
    if {$ID4Current=="?"} {
        APSMpReturn error "APSMpResetCPUAfg: can not read value of ID04b:set_V_coil"
    }
    if [catch {exec cavput -list=ID04b:TriggerSelect.VAL=Internal,ID04b:DesiredMode.VAL=CW/CCW -pend=30} result] {
         APSMpReturn error "APSMpResetCPUAfg: $result"
    }
    if [catch {exec cavput -list=ID04b:set_V_coil=0,ID04b:on_off=Off -pend=30} result] {
        APSMpReturn error "APSMpResetCPUAfg: $result"
    }
    
    APSMpStep "ResetCPUAfg - Step 1: Check if RTFB is running."
    #make sure RTFB (e.g. SRFB:GBL:HLoopStatusBI) is running in both
    #planes with sector 5 loops closed. (it is possible to have RTFB running
    #with some particular sectors open. It happened to me
    #during the procedure tests due to not reseting from a previous trip.
    #So all sector loops, e.g. S1FB:GB2:Hor:CloseLoopBO have to be checked.)
    #If some loops are open, reset/open all loops, and re-close them.
    if [catch {exec cavget -list=SRFB:GBL: -list=H,V -list=LoopStatusBI -pend=30 -printErrors} valList] {
        APSMpReturn error "APSMpResetCPUAfg: $valList"
    }
    foreach val $valList nm {horizontal vertical} {
        if {$val!="On"} {
            APSMpReturn error "APSMpResetCPUAfg: the $nm plane RTFB is not running!"
        }
    }
    #check if any loops are open
    for {set i 2} {$i<=39} {incr i} {
        set ioc [expr ($i - 1) / 2 * 2 + 1]
        lappend crateList S${ioc}FB:GB${i}
    }
    if [catch {exec cavget -list=[join $crateList ,] -list=:Hor,:Vert -list=:CloseLoopBO -pend=30 -printErrors -label} loopList] {
        APSMpReturn error "APSMpResetCPUAfg: $loopList"
    }
    if [lsearch -exact $loopList "Open"]>=0 {
        APSMpStep "ResetCPUAfg - Step 1a: Reset/Open RTFB Loops"
        global apshpFilterCutoffVert apshpFilterCutoffHoriz apshpFilterInitialVert apshpFilterInitialHoriz apshpFilterRampPoints apshpFilterRampInterval
        APSMpSetRTFBGlobalParameters -readonly 1 
        if [catch {APSMpRTFBResetOpenLoops -hpFilterInitialVert $apshpFilterInitialVert \
                       -hpFilterInitialHoriz $apshpFilterInitialHoriz } result] {
            APSMpReturn error "APSMpResetCPUAfg (open RTFB loops): $result"
        }
        APSMpStep "ResetCPUAfg - Step 1c: Close RTFB loops - this will take some time for ramping."
        if [catch {APSMpRTFBCloseLoops -hpFilterCutoffVert $apshpFilterCutoffVert \
                       -hpFilterCutoffHoriz $apshpFilterCutoffHoriz \
                       -hpFilterInitialVert $apshpFilterInitialVert \
                       -hpFilterInitialHoriz $apshpFilterInitialHoriz \
                       -hpFilterRampPoints $apshpFilterRampPoints \
                       -hpFilterRampInterval $apshpFilterRampInterval } result] {
            APSMpReturn error "APSMpResetCPUAfg (cloose RTFB loops): $result"
        }   
    }
    APSMpStep "ResetCPUAfg - Step 2: Change RTFB trip limit."
    if [catch {exec cavput -list=SRFB:GBL:HCorDeltaMaxP=50,SRFB:GBL:VCorDeltaMaxP=50 \
                   -pend=30} result] {
        APSMpReturn error "APSMpResetCPUAfg: $result"
    }
    if [catch {exec cavput -list=SRFB:GBL:loadBO=1 -pend=30} result] {
        APSMpReturn error "APSMpResetCPUAfg: $result"
    }
    
    APSMpStep "ResetCPUAfg - Step 3: Change datapool despiking limit for H plane."
    if [catch {exec cavput -list=DP:S:OrbitControlLawXSDDS.SPKE=1 -pend=30} result] {
        APSMpReturn error "APSMpResetCPUAfg: $result"
    }

    APSMpStep "ResetCPUAfg - Step 4: Increase datapool corrector range limit to 20 A for both planes and generate controllaw files."
    APSInfoWindow .info -name "Regenerate controllaw files." -modal 1\
        -width 50 -infoMessage "ResetCPUAfg - Step 4: Increase datapool corrector range limit to 20 A \n\n Go to SR orbit correction application,\n\n increase the corrector range limit to 20 A for both planes, \n\n and then press \"GENERATE\" and \"START PVTEST\" for both planes."
    APSMpStep "ResetCPUAfg - Step 5: reset AFG."
    APSInfoWindow .info -name "Reset AFG" -width 50 -modal 1\
        -infoMessage "ResetCPUAfg - Step 5: reset AFG\n\ngo to CPU cabinet, look for VME crate (accessible through a hole in the door)\n\n and press the red rest button on the AFG card. The reset operation takes a few seconds. \n You can check that the corrector channels are zero, by opening the door of the left cabinet,\n and read the KEPCO supply LED displays."
    APSMpStep "ResetCPUAfg - Step 6: start CPU operation."
    #ask louis how ???
    if [catch {exec cavput -list=ID04b:set_V_coil=$ID4Current,ID04b:on_off=On -pend=30} result] {
        APSMpReturn error "APSMpResetCPUAfg: $result"
    }
    
    APSMpStep "ResetCPUAfg - Step 7: Return datapool corrector range limit to 10A."
    APSInfoWindow .info -name "Regenerate controllaw files." -modal 1 \
        -width 50 -infoMessage "ResetCPUAfg - Step 6: Return datapool corrector range limit to 10A\n\nGo to SR orbit correction application, \n\n return the corrector range limit to 10 A for both planes, \n\n and press \"GENERATE\" and \"START PVTEST\" for both planes."
    
    APSMpStep "ResetCPUAfg - Step 8: Reramp datapool despiking limit."
    APSInfoWindow .info -name "Reramp datapool despiking limit." -modal 1 \
        -width 50 -infoMessage "ResetCPUAfg - Step 8: Reramp datapool despiking limit.\n\n Go to orbit correction application, \n\n press \"Re-ramp Despike Threshold\" button in the \"Depike Threshold Ramp\" tab to reramp datapool despiking limit."

    APSMpStep "ResetCPUAfg - Step 9: Restore the RTFB trip limits."
    if [catch {exec cavput -list=SRFB:GBL:HCorDeltaMaxP=10,SRFB:GBL:VCorDeltaMaxP=10 -pend=30} result] {
        APSMpReturn error "APSMpResetCPUAfg: $result"
    }
    if [catch {exec cavput -list=SRFB:GBL:loadBO=1 -pend=30} result] {
        APSMpReturn error "APSMpResetCPUAfg: $result"
    }
    APSMpReturn ok
}

proc APSMpIDRestoreMinimumGapsInfo {args} {
    return "Restore the minumum gaps from /home/helios/oagData/sr/IDs/MinimumGaps file"
}

proc APSMpIDRestoreMinimumGapsInitDialog {frame} {
    global APSMpIDRestoreMinimumGaps
    set APSMpIDRestoreMinimumGaps(closeInterval) 3
    APSLabeledEntry .interval -parent $frame -textVariable  APSMpIDRestoreMinimumGaps(closeInterval) \
      -label "Interval of closing gaps (seconds):" -width 20 \
      -contextHelp "Due to on-going restrictions on the SR rf systems, we need to tagger the closing of the gaps by a selectable time interval, i.e. issuing the next gap close command after T seconds of the previous one."
    
}

proc APSMpIDRestoreXbpmRefGapsInitDialog {frame} {
    global APSMpIDRestoreXbpmRefGaps
    
    set APSMpIDRestoreXbpmRefGaps(closeInterval) 3
    APSLabeledEntry .interval -parent $frame -textVariable  APSMpIDRestoreXbpmRefGaps(closeInterval) \
      -label "Interval of closing gaps (seconds):" -width 20 \
      -contextHelp "Due to on-going restrictions on the SR rf systems, we need to tagger the closing of the gaps by a selectable time interval, i.e. issuing the next gap close command after T seconds of the previous one."
    set APSMpIDRestoreXbpmRefGaps(group) ""
    APSRadioButtonFrame .group -parent $frame -variable APSMpIDRestoreXbpmRefGaps(group) \
      -label "Select group of gaps to restore:" -buttonList {"A" "B" "Both"} \
      -valueList {A B Both} \
      -contextHelp "due to higher amount of forward power needed if close all gaps, now split the xbpm reference gaps into group a and b, user may \
choose which group (A or B) to restore, or restore all gaps (both) if allowed."

    
    
}
proc APSMpIDRestoreXbpmRefGaps {args} {
    set closeInterval 3
    set group ""
    set orbitSwitch 0
    set pem 1
    set wait 1
    APSStrictParseArguments {closeInterval group orbitSwitch pem wait}

    APSMpStep init -promptDialog "APSMpIDRestoreXbpmRefGapsInitDialog" -vars {closeInterval group}
    
    if ![string length $group] {
        APSMpReturn error "ID gap group is not provided."
    }
    APSMpStep "Restore Xray bpm ref gaps..."
    if [catch {APSCloseID35Shutter} result] {
        APSMpReturn error "APSMpIDRestoreXbpmRefGaps: error in closing ID35 shutter: $result"
    }
    if {$group=="Both"} {
        set file XbpmRefGaps
    } else {
        set file XbpmRefGaps$group
    }
    if [catch {APSMpIDRestoreGaps -gapfile $file -closeInterval $closeInterval -orbitSwitch $orbitSwitch -pem $pem -wait $wait} result] {
        APSAlertBox .error -errorMessage "APSMpIDRestoreXbpmRefGaps: $result"
        APSMpReturn error "APSMpIDRestoreXbpmRefGaps: $result"
    }
    APSMpStep "Restore Xbpm Reference gaps done."
    APSMpReturn ok
}

proc APSMpIDRestoreMinimumGaps {args} {
    set closeInterval 3
    APSStrictParseArguments {closeInterval}

    APSMpStep init -promptDialog "APSMpIDRestoreMinimumInitDialog" -vars closeInterval
    
    APSMpStep "Restore Xray bpm minimum gaps..."
    if [catch {APSCloseID35Shutter} result] {
        APSMpReturn error "APSMpIDRestoreMinimumGaps: error in closing ID35 shutter: $result"
    }
    if [catch {APSMpIDRestoreGaps -gapfile MinimumGaps -closeInterval $closeInterval} result] {
        APSAlertBox .error -errorMessage "APSMpIDRestoreMinimuGaps: $result"
        APSMpReturn error "APSMpIDRestoreMinimumGaps: $result"
    }
    APSMpStep "Restore minimum gaps done."
    APSMpReturn ok
}

proc APSMpIDRestoreXbpmRefGapsInfo {args} {
    return "Restore the xray bpm gaps from /home/helios/oagData/sr/IDs/XbpmRefGaps file if group \"Both\" selected, or XbpmRefGapA for group \"A\" or XbpmRefGapsB for group \"B\"."
}
proc APSMpIDSetGapTo60mmInfo {args} {
    return "Restore the xray bpm gaps from /home/helios/oagData/sr/IDs/SetGapTo60mm file"
}
proc APSMpIDSetGapTo180mmInfo {args} {
    return "Restore the xray bpm gaps from /home/helios/oagData/sr/IDs/SetGapTo180mm file"
}
proc APSMpIDSetGapToMinimumInfo {args} {
    return "Restore the xray bpm gaps from /home/helios/oagData/sr/IDs/MinimumGaps file"
}
proc APSMpIDSetGapToMinimumInitDialog {frame} {
    global APSMpIDSetGapToMinimum
    set APSMpIDSetGapToMinimum(closeInterval) 3
    APSLabeledEntry .interval -parent $frame -textVariable  APSMpIDSetGapToMinimum(closeInterval) \
      -label "Interval of closing gaps (seconds):" -width 20 \
      -contextHelp "Due to on-going restrictions on the SR rf systems, we need to tagger the closing of the gaps by a selectable time interval, i.e. issuing the next gap close command after T seconds of the previous one."
    
}

proc APSMpIDSetGapToMinimum {args} {
    set closeInterval 3
    APSStrictParseArguments {closeInterval}
    APSMpStep init -promptDialog "APSMpIDSetGapToMinimumInitDialog" -vars closeInterval
    APSMpStep "Set Xray bpm gaps to minim gap values..."
    if [catch {APSCloseID35Shutter} result] {
        APSMpReturn error "APSMpIDSetGapToMinimum: error in closing ID35 shutter: $result"
    }
    if [catch {APSMpIDRestoreGaps -gapfile MinimumGaps -closeInterval $closeInterval } result] {
        APSAlertBox .error -errorMessage "APSMpIDSetGapToMinimum: $result"
        APSMpReturn error "APSMpIDSetGapToMinimum: $result"
    }
    APSMpStep "Set Xray bpm gaps to minimum gaps done."
    set IDList [exec sdds2stream -col=GapName /home/helios/oagData/sr/IDs/MinimumGaps]
    if [catch {APSIDsGoAndWait -IDList "$IDList"} result] {
        APSMpReturn error "APSMpIDSetGapToMinimum: $result"
    }
    APSMpStep "Routine SCR Save after gaps moved minimum gap."
    if [catch {APSSaveMachine -machine SR \
                 -description "Routine save: save after gaps moved to minimum gap."} result] {
        APSMpReturn error "APSMpIDSetGapToMinimum: $result"
    }
    APSMpStep "XrayBPM Save after gaps moved to minimum gap"
    if [catch {APSSaveMachine -machine SRXrayBPM \
                 -description "XrayBPM Save gaps moved to minimum gap."} result] {
        APSMpReturn error "APSMpIDSetGapToMinimum: $result"
    }
    
    APSMpReturn ok
}

proc APSMpIDSetGapTo60mmInitDialog {frame} {
    global APSMpIDSetGapTo60mm
    set APSMpIDSetGapTo60mm(closeInterval) 3
    APSLabeledEntry .interval -parent $frame -textVariable  APSMpIDSetGapTo60mm(closeInterval) \
      -label "Interval of closing gaps (seconds):" -width 20 \
      -contextHelp "Due to on-going restrictions on the SR rf systems, we need to tagger the closing of the gaps by a selectable time interval, i.e. issuing the next gap close command after T seconds of the previous one."
    
}

proc APSMpIDSetGapTo60mm {args} {
    set closeInterval 3
    set orbitSwitch 1
    APSStrictParseArguments {closeInterval orbitSwitch}

    
    APSMpStep init -promptDialog "APSMpIDSetGapTo60mmInitDialog" -vars "closeInterval"
  
    APSMpStep "Set Xray bpm gaps to 60mm..."
    if [catch {APSMpIDRestoreGaps -gapfile SetGapTo60mm -closeInterval $closeInterval -orbitSwitch $orbitSwitch} result] {
        APSAlertBox .error -errorMessage "APSMpIDSetGapTo60mm: $result"
        APSMpReturn error "APSMpIDSetGapTo60mm: $result"
    }
    APSMpStep "Set Xray bpm gaps to 60mm done."
    APSMpReturn ok
}

proc APSMpIDSetGapTo180mm {args} {
    set orbitSwitch 1
    APSStrictParseArguments {orbitSwitch}
    APSMpStep init -promptDialog "APSMpPromptInitDialog"
    APSMpStep "Set Xray bpm gaps to 180mm..."
    if [catch {APSMpIDRestoreGaps -gapfile SetGapTo180mm -closeInterval 0.1 -orbitSwitch $orbitSwitch} result] {
        APSAlertBox .error -errorMessage "APSMpIDSetGapTo180mm: $result"
        APSMpReturn error "APSMpIDSetGapTo180mm: $result"
    }
    APSMpStep "Set Xray bpm gaps to 180mm done."
    APSMpReturn ok
}

proc APSMpIDRestoreOpenGapsInfo {args} {
    return "Open gaps"
}

proc APSMpIDRestoreOpenGaps {args} {
    set orbitSwitch 1
    APSStrictParseArguments {orbitSwitch}
    APSMpStep "Open Xray bpm gaps..."
    if [catch {APSMpIDRestoreGaps -gapfile OpenGaps -orbitSwitch $orbitSwitch} result] {
        APSAlertBox .error -errorMessage "APSMpIDRestoreOpenGaps: $result"
        APSMpReturn error "APSMpIDRestoreOpenGaps: $result"
    }
    APSMpStep "Open xray bpm gaps done."
    APSMpReturn ok
}

proc APSSRPrepareMovingID01Gaps {args} {
    set dsGap ""
    set usGap ""
    set orbitSwitch 0
    APSParseArguments {dsGap usGap orbitSwitch}
    
    if {![string length $dsGap] && ![string length $usGap]} {
        #gaps not provided, do nothing.
        return
    }
    if [catch {exec cavget -list=ID01 -list=ds,us -list=:Gap -pend=30} gaps] {
        return -code error "APSSRPrepareMovingID01Gaps1: error reading ID01 gaps: $gaps"
    }
    set DSgap [lindex $gaps 0]
    set USgap [lindex $gaps 1]
    if [catch {exec cavget -list=ID01ds:MainOn -num -pend=30} scu1OnOff] {
        return -code error "APSSRPrepareMovingID01Gaps2: error reading ID01ds on/off:$ scu1OnOff"
    }
    if {[string length $dsGap] && [string length $usGap] && $dsGap<170 && $usGap<170} {
        return -code error "APSSRPrepareMovingID01Gaps3: error: ID01 ds and us can not close at the same time!"
    }
    if {$orbitSwitch && [string length $dsGap] && $dsGap>170 && $scu1OnOff} {
        #turn off scu1 for orbitSwitch when opening SCU1.
        APSMpStep "Turn off SCU1 after opening SCU1 in orbit switch..."
        if [catch {exec cavput -list=ID01ds:Main_OnOff=0  -pend=30
            exec cawait -interval=1 -timelimit=600 -waitFor=ID01ds:Gap,lower=179,upper=181 } result] {
            return -code error "APSSRPrepareMovingID01Gaps4: Error opening ID01ds gap: $result"
        }
        #scu1 is off now
        set scu1OnOff 0
    }
    #it is ok if both are greater than 170
    
    if {[string length $usGap] && $usGap<170 && $scu1OnOff} {
        #need open SCU1 and then turn it off
        if [string length $dsGap] {
            set gap $dsGap
            set low [expr $gap -1]
            set upper [expr $gap +1]
        } else {
            set gap 180
            set low 179
            set upper 181
        }
        #SCU1 is on
        if {$DSgap<$gap} {
            #turn scu1 off and wait for it open
            APSMpStep "turn off SCU1 and wait for its current turning to zero (be patient, it may take several minutes)..."
            if [catch {exec cavput -list=ID01ds:Main_OnOff=0  -pend=30
                exec cawait -interval=1 -timelimit=600 -waitFor=ID01ds:Gap,lower=$low,upper=$upper } result] {
                return -code error "APSSRPrepareMovingID01Gaps4: Error opening ID01ds gap: $result"
            }
            while {1} {
                if [catch {exec cavget -list=ID01ds:MainOn -num -pend=30} onOff] {
                    return -code errr "APSSRPrepareMovingID01Gaps4a: error reading ID01ds:MainOn: $onOff"
                }
                if {!$onOff} {
                    break
                }
                set answer [APSMultipleChoice [APSUniqueName .] -modal 1 \
                              -question "SCU1 is not off yet, would you like turn in off again or abort" \
                              -returnList {1 0} \
                              -labelList {Turn_Off_Again Abort}]
                if !$answer {
                    return -code error "APSSRPrepareMovingID01Gaps4b: can not turn off SCU1!"
                }
                if [catch {exec cavput -list=ID01ds:Main_OnOff=0  -pend=30 } result] {
                    return -code error "APSSRPrepareMovingID01Gaps4c: Error turning off SCU1: $result"
                }
                APSWaitWithUpdate -waitSeconds 5 -update 1
            }
        }
    }
    #if SCU1 is off, the gap must be 180, nothing need to do.
    if {[string length $dsGap] && $dsGap<170 && !$scu1OnOff} {
        #open ID01us
        if [string length $usGap] {
            set gap $usGap
            set low [expr $gap -1]
            set upper [expr $gap +1]
        } else {
            set gap 180
            set low 179
            set upper 181
        }
        if {$USgap<$gap} {
            APSMpStep "Opening ID01us gap..."
            if [catch {exec cavput -list=ID01us:GapSet.VAL=$gap -pend=30
                exec cavput -list=ID01us:Start=1  -pend=30
                exec cawait -interval=1 -timelimit=500 -waitFor=ID01us:Gap,lower=$low,upper=$upper } result] {
                return -code error "APSSRPrepareMovingID01Gaps6: Error opening ID01us gap: $result"
            }
        }
        #turn on SCU1
        APSMpStep "Waiting for SCU1 to turn on..."
        while {1} {
            if [catch {exec cavput -list=ID01ds:Main_OnOff=1 -pend=30 } result] {
                return -code error "APSSRPrepareMovingID01Gaps7: Error turning on ID01ds: $result"
            }
            APSWaitWithUpdate -waitSeconds 20 -update 1
            if [catch {exec cavget -list=ID01ds:MainOn -num -pend=30} onOff] {
                return -code errr "APSSRPrepareMovingID01Gaps8: error reading ID01ds:MainOn: $onOff"
            }
            if $onOff {
                break
            }
            set answer [APSMultipleChoice [APSUniqueName .] -modal 1 \
                          -question "SCU1 is not on yet, would you like turn in on again or abort" \
                          -returnList {1 0} \
                          -labelList {Turn_On_Again Abort}]
            if !$answer {
                return -code error "APSSRPrepareMovingID01Gaps9: can not turn SCU1 on!"
            }
        }
    }
}

#ID 06 us (regular gap) and ID06ds (SCU0)
proc APSSRPrepareMovingSCU0Gaps {args} {
    set gapList ""
    set IDList ""
    set orbitSwitch 0
    APSParseArguments {gapList IDList orbitSwitch}
    
    if {![llength $gapList]} {
        return -code error "APSSRPrepareMovingSCU0Gaps0: gapList not provided."
    }
    if {![llength $IDList]} {
        return -code error "APSSRPrepareMovingSCU0Gaps0: IDList not provided."
    }
    
    if [catch {exec cavget -list=[join $IDList ,]-list=:Gap -pend=30} gaps] {
        return -code error "APSSRPrepareMovingSCU0Gaps1: error reading $IDList gaps: $gaps"
    }
    
    foreach ID $IDList gapRead $gaps gap $gapList {
        if [catch {exec cavget -list=$ID:MainOn -num -pend=30} onOff1] {
            return -code error "APSSRPrepareMovingSCU0Gaps2: error reading $ID on/off: $onOff1"
        }
        if {$gap>170 && $onOff1} {
            APSMpStep "Turn off $ID after opening it, be patient (it may take several minutes) ..."
            if [catch {exec cavput -list=$ID:Main_OnOff=0  -pend=30
                exec cawait -interval=1 -timelimit=600 -waitFor=$ID:Gap,lower=179,upper=181 } result] {
                return -code error "APSSRPrepareMovingSCU0Gaps4: Error opening $ID gap: $result"
            }
            while {1} {
                if [catch {exec cavget -list=$ID:MainOn -num -pend=30} onOff] {
                    return -code errr "APSSRPrepareMovingSCU0Gaps4a: error reading $ID:MainOn: $onOff"
                }
                if {!$onOff} {
                    break
                }
                set answer [APSMultipleChoice [APSUniqueName .] -modal 1 \
                              -question "$ID is not off yet, would you like turn in off again or abort" \
                              -returnList {1 0} \
                              -labelList {Turn_Off_Again Abort}]
                if !$answer {
                    return -code error "APSSRPrepareMovingSCU0Gaps4b: can not turn off SCU0!"
                }
                if [catch {exec cavput -list=$ID:Main_OnOff=0  -pend=30 } result] {
                    return -code error "APSSRPrepareMovingSCU0Gaps4c: Error turning off $ID: $result"
                }
                APSWaitWithUpdate -waitSeconds 5 -update 1
            }
            
        } elseif {$gap<170 && !$onOff1} {
            #if gap < 170 and gap is off, turn it on
            APSMpStep "Turn on $ID, wait for 60 seconds..."
            if [catch {exec cavput -list=$ID:Main_OnOff=1  -pend=30 } result] {
                return -code error "APSSRPrepareMovingSCU0Gaps5: Error turning on $ID gap: $result"
            }
            APSWaitWithUpdate -waitSeconds 60 -update 1
            while {1} {
                if [catch {exec cavget -list=$ID:MainOn -num -pend=30} onOff] {
                    return -code errr "APSSRPrepareMovingSCU0Gaps5a: error reading $ID:MainOn: $onOff"
                }
                
                if {$onOff} {
                    break
                }
                
                set answer [APSMultipleChoice [APSUniqueName .] -modal 1 \
                              -question "$ID is not on would you like turn in on again or abort" \
                              -returnList {1 0} \
                              -labelList {Turn_On_Again Abort}]
                if !$answer {
                    return -code error "APSSRPrepareMovingSCU0Gaps5b: can not turn on SCU0!"
                }
                if [catch {exec cavput -list=$OD:Main_OnOff=1  -pend=30 } result] {
                    return -code error "APSSRPrepareMovingSCU0Gaps5c: Error turning on $ID: $result"
                }
                APSWaitWithUpdate -waitSeconds 5 -update 1
            }
        }
    }
}

proc APSMpIDRestoreGaps {args} {
    set gapfile ""
    set wait 0
    set confirm 1
    set switchToMachinePhysics 1
    set closeInterval 3
    set orbitSwitch 0
    set pem 1
    APSParseArguments {gapfile wait confirm switchToMachinePhysics closeInterval orbitSwitch pem}
    
    # Get a list of all the installed devices.
    set deviceList [APSIDGetDeviceList]
    set taperList [APSIDGetTaperDeviceList]
    if $switchToMachinePhysics {
        #first change to machine physics mode
        APSMpStep "Set global access security mode to Machine Physics"
        if [catch {exec cavput -list=[join $deviceList ,] \
                       "-list=:AccessSecurity=Machine Physics"} result] {
            APSMpReturn error "APSMpIDRestoreGaps(1 - cavput access mode): $result"
        }
    }
    if [catch {exec cavget -list=[join $taperList ,] -list=:TaperGap.VAL -pend=30 -printErrors} taperValList] {
        APSMpReturn error "APSMpIDRestoreGaps(2 - cavget tapergap): $taperValList"
    }
    after 1000
    APSMpStep "Restore Xray bpm gaps..."
    set gapfile /home/helios/oagData/sr/IDs/$gapfile
    set tmpfile /tmp/[APSTmpString]
    APSAddToTmpFileList -ID 1 -fileList $tmpfile.taperset
    if [catch {exec sddsmakedataset -pipe=out -col=DeviceName,type=string \
		   -data=[join $taperList ,] \
		   -col=Value,type=double -data=[join $taperValList ,] \
		   | sddsxref -pipe $gapfile -match=DeviceName=GapName -nowarnings -leave=* \
		   | sddsprocess -pipe=in $tmpfile.taperset \
		   -edit=col,ControlName,DeviceName,ei/:TaperGapSet.VAL// \
		   -filter=col,Value,0,0,! \
		   -reprint=col,ValueString,0 \
	       } result] {
        APSMpReturn error "APSMpIDRestoreGaps(3 - sddsmakedataset): $result"
    }
    set movableList [APSIDGetDeviceList -full 0]
    set badList [APSIDGetBadDeviceList]
    if [llength $badList] {
	APSAlertBox .warning -errorMessage "The [join $badList ,] gaps will not be moved, because their :MotorDriveStatus are not ready. Please contact control group if you need move them."
    }
    if [catch {exec sddsmakedataset $tmpfile.full -col=DeviceName,type=string -data=[join $movableList ,]} result] {
        APSMpReturn error "APSMpIDRestoreGaps(4 - sddsmakedataset): $result"
    }
    APSAddToTmpFileList -ID 1 -fileList "$tmpfile.set $tmpfile.printout $tmpfile.start $tmpfile.full"
    
    if [catch {exec sddsselect $gapfile $tmpfile.full -pipe=out -match=GapName=DeviceName -nowarnings  \
                   | sddsconvert -pipe -retain=col,GapName,ReadbackName,ValueString \
                   | sddsprocess -pipe -scan=col,MoveGapTo,ValueString,%f,type=float \
                   | sddsconvert -pipe -rename=col,ReadbackName=ControlName \
                   | sddscasr -pipe -save \
                   | sddsprocess -pipe=in $tmpfile.set \
                   -reedit=col,ControlName,%/:Gap.VAL/:GapSet.VAL/ \
                   -scan=col,PresentValue,ValueString,%f,type=float \
                   -reprint=col,ValueString,%f,MoveGapTo} result] {
        APSMpReturn error "APSMpIDRestoreGaps(5 - sddsselect): $result"
    }

    
    if [regexp "SetGapTo60mm" $gapfile] {
        #leave the gaps alone if their values are greater than "60mm"
        if [catch {exec sddsprocess $tmpfile.set $tmpfile.set1 "-test=col,MoveGapTo PresentValue >" -nowarnings} result] {
            APSMpReturn error "APSMpIDRestoreGaps(5b - sddsprocess): $result"
        }
        set rows [exec sdds2stream -rows=bar $tmpfile.set1]
        if !$rows {
            #all gaps are equal to or bigger than "60mm"
            APSMpReturn ok
        }
        exec mv $tmpfile.set1 ${tmpfile}.set
    }
    if [catch {exec sddsprocess $tmpfile.set $tmpfile.start \
                   -reedit=col,ControlName,%/:GapSet.VAL/:Start.VAL/ \
                   -reprint=col,ValueString,1 } result] {
        APSMpReturn error "APSMpIDRestoreGaps(6 - sddsprocess): $result"
    }
    if $confirm {
        if [catch {exec sddsprintout $tmpfile.set $tmpfile.printout \
                       "-title=The current gap values and the values that gaps are going to be moved to." \
                       -col=ControlName,format=%30s \
                       -col=PresentValue,format=%.3f -col=MoveGapTo,format=%.3f } result] {
            APSMpReturn error "APSMpIDRestoreGaps(7 - sddsprintout): $result"
        }
        global moveGaps
        set movegaps ""
        APSFileDisplayWindow .gap -fileName $tmpfile.printout -width 80 -modal 1 \
          -closeButton 0 -okButton 1 -cancelButton 1 -okCommand "set moveGaps 1;destroy .gap" \
          -cancelCommand "set moveGaps 0;destroy .gap"
        
        if !$moveGaps {
            APSMpStep "Moving gaps was canceled!"
            APSMpReturn ok
        }
    }
    APSMpStep "Setting gap tapper to zero..."
    if [catch {exec sddscasr -restore $tmpfile.taperset} result] {
        APSMpReturn error "APSMpIDRestoreGaps(8 - sddscasr -restore $tmpfile.taperset): $result"
    }
    
    APSMpStep "Moving Xray bpm gaps (it may be take minutes)"
    if [catch {exec sddscasr -restore $tmpfile.set } result] {
        APSMpReturn error "APSMpIDRestoreGaps(9 - sddscasr -restore $tmpfile.set): $result"
    }
    
    set waitList [exec sdds2stream -col=GapName $tmpfile.set]
    if $pem {
        if [catch {APSIDStaggerGaps -IDList $waitList -returnGaps 0 -interval $closeInterval} result] {
            APSMpReturn error "APSMpIDRestoreGaps(10): error in stagger gaps: $result"
        }
    } else {
        #can not run in parallel without pem
        set scuList ""
        set otherGaps ""
        set moveID01us 0
        foreach ID $waitList {
            if {$ID=="ID01ds" || $ID=="ID06ds" || $ID=="ID07ds"} {
                lappend scuList $ID
            } elseif {$ID=="ID01us"} {
                set moveID01us 1
            } else {
                lappend otherGaps $ID
            }
        }
        if [llength $otherGaps] {
            if [catch {APSIDMoveRegularGaps -IDList $otherGaps -interval $closeInterval} result] {
                return -code error "APSSRMoveIDGaps13: $result"
            }
        }
        if [llength $scuList] {
            foreach ID $scuList {
                if [catch {exec cavget -list=$ID:GapSet -pend=20 -printErrors} value] {
                    return -code error "APSSRMoveIDGaps14: Error reading $ID:GapSet: $value"
                }
                if [catch {APSSRMoveSCUID -ID $ID -moveTo $value} result] {
                    return -code error "APSSRMoveIDGaps15: error moving SCU $ID: $result"
                }
            }
        }
        if $moveID01us {
            if [catch {exec cavget -list=ID01us:GapSet -pend=20 -printErrors} value] {
                return -code error "APSSRMoveIDGaps16: Error reading ID01us:GapSet: $value"
            }
            if [catch {APSSRMoveID01US -moveTo $value} result] {
                return -code error "APSSRMoveIDGaps17: error moving ID01us gap: $result"
            }
        }
    }
    after 1000
    if {$wait && [llength $waitList]} {
        if {[catch {APSMpCheckAndWaitForIDs -deviceList $waitList} results]} {
            if {[APSPEMTKDialog .warningDialog -text "APSMpIDRestoreGaps: Problem occurred while waiting restoring ID gaps\n$results"] == 1} {
                APSMpReturn error "APSMpIDRestoreGaps(20): $results"
            }
        }
    }
    APSMpReturn ok
}

proc APSMpWaitForIDs {args} {
    #wait for ID gaps stop moving
    set deviceList ""
    set timeout 0
    APSStrictParseArguments {deviceList timeout}
    
    if ![llength $deviceList] {
        APSMpReturn ok
    }
    set options ""
    set first 1
    foreach device $deviceList {
        if $first {
            set options "-waitFor=${device}:Busy,equalTo=0"
            set first 0
        } else {
            append options " -waitFor=${device}:Busy,equalTo=0"
            append options " -and"
        }
    }
    if $timeout {
        append options " -timeLimit=$timeout"
    }
    update
    if [catch {eval exec cawait $options} result] {
        APSMpReturn error "APSMpWaitForIDs: $result"
    }
    update
    APSMpReturn ok
}

proc APSMpIDRestoreGapsFromSCRInfo {} {
    return "It restores selected user gap values from an SCR file. Restores the gap setpoints and gap taper setpoints.  Optionally moves the gaps to the setpoints or return values."
}

proc APSMpIDRestoreGapsFromSCRInitDialog {frame args} {
    global APSMpIDRestoreGapsFromSCR
    set deviceList0 [lsort [array names  APSMpIDRestoreGapsFromSCR]]
    set APSMpIDRestoreGapsFromSCR(closeInterval) 3
    foreach item $deviceList0 {
        if [string match ID* $item] {
            lappend deviceList $item
            lappend variableList APSMpIDRestoreGapsFromSCR($item)
        }
    }
    set pem 1
    set label ""
    APSParseArguments {pem label}
    if !$pem {
        set  APSMpIDRestoreGapsFromSCR(cancel) 0
        APSDialogBox .idscr -name $label -cancelCommand "set APSMpIDRestoreGapsFromSCR(cancel) 1"
        set frame .idscr.userFrame
    }
    APSCheckButtonFrame .cb -parent $frame -label "Choose IDs" \
        -limitPerRow 8 -buttonList "$deviceList" \
        -variableList "$variableList" -orientation horizontal -allNone 1 
    APSLabeledEntry .interval -parent $frame -textVariable  APSMpIDRestoreGapsFromSCR(closeInterval) \
      -label "Interval of closing gaps (seconds):" -width 70 \
      -contextHelp "Due to on-going restrictions on the SR rf systems, we need to tagger the closing of the gaps by a selectable time interval, i.e. issuing the next gap close command after T seconds of the previous one."
    APSAddSCRDialog .scr -parent $frame -system SR \
        -arrayName APSMpIDRestoreGapsFromSCR \
        -defaultFile $APSMpIDRestoreGapsFromSCR(ShortFilename)
    if !$pem {
        tkwait window .idscr
        if $APSMpIDRestoreGapsFromSCR(cancel) {
            APSMpReturn error "Restore ID gaps from SCR was cancelled."
        }
    }
}

proc APSMpIDRestoreGapsFromSCR {args} {
    global APSMpIDRestoreGapsFromSCR
    set pem 1
    set label ""
    set fullDeviceList [APSIDGetDeviceList -full 0]
    set deviceList $fullDeviceList
    set closeInterval 3
    set ShortFilename ""
    set orbitSwitch 0
    APSStrictParseArguments {deviceList closeInterval pem label ShortFilename orbitSwitch}

    foreach item $fullDeviceList {
        set APSMpIDRestoreGapsFromSCR($item) 1
        if [lsearch -exact $deviceList $item]!=-1 {
            set $item 1
        } else {
            set $item 0
        }
    }
    if ![string length $ShortFilename] {
        if $pem {
            set ShortFilename ""
            APSMpStep init -promptDialog  APSMpIDRestoreGapsFromSCRInitDialog \
              -desc "Choose devices and SCR file"   \
              -vars "$fullDeviceList ShortFilename closeInterval"
        } else {
            set APSMpIDRestoreGapsFromSCR(ShortFilename) ""
            if [catch {APSMpIDRestoreGapsFromSCRInitDialog frame -pem 0 -label $label } result] {
                APSMpReturn error $result
            }
            set ShortFilename $APSMpIDRestoreGapsFromSCR(ShortFilename)
            set closeInterval $APSMpIDRestoreGapsFromSCR(closeInterval)
            set deviceList ""
            foreach item $fullDeviceList {
                if $APSMpIDRestoreGapsFromSCR($item) {
                    set $item 1
                    lappend deviceList $item
                } else {
                    set $item 0
                }
            }
        }
    }
    if ![string length $ShortFilename] {
        APSMpReturn error "APSMpIDRestoreGapsFromSCR: No file chosen."
    }
    set fullFilename /home/helios/oagData/SCR/snapshots/SR/$ShortFilename
    if {[string length $ShortFilename] && ![file exists $fullFilename]} {
        APSMpReturn error "APSMpIDRestoreGapsFromSCR: SCR file $ShortFilename not found"
    }
    set varList "$fullDeviceList ShortFilename"
    foreach par $varList {
        append paramString "$par=\"[set $par]\" "
    }
    catch {APSLogScriptAction  \
               -procedure  APSMpIDRestoreGapsFromSCR  \
               -action initialize \
               -state ok \
               -parameters $paramString \
           }
    set first 1
    set deviceList ""
    set matchOpt ""
    foreach device $fullDeviceList {
        if {[set $device]} {
            lappend deviceList $device
            if $first {
                set first 0
                set matchOpt -match=column,ControlName=$device:GapSet,ControlName=$device:TaperGapSet,|
            } else {
                set matchOpt $matchOpt,ControlName=$device:GapSet,|,ControlName=$device:TaperGapSet,|
            }
        }
    }
    if ![llength $deviceList] {
        APSMpStep "No devices selected"
        APsMpReturn ok
    }
    
    #if [catch {exec cavget -list=[join $deviceList ,] -list=:Busy -numerical \
    #             -pend=30 -printErrors} busyList] {
     #   APSMpReturn error "APSMpIDRestoreGapsFromSCR: $busyList"
    #}
    
    APSMpStep "Prepare device values"
    set tmpFile /tmp/[APSTmpString]
    APSAddToTempFileList $tmpFile
    if [catch {exec sddsprocess $fullFilename $tmpFile $matchOpt} result] {
        APSMpReturn error "APSMpIDRestoreGapsFromSCR: $result"
    }
    
    APSMpStep "Restore device values"
    if [catch {exec sddscasr -restore $tmpFile } result] {
        APSMpReturn error "APSMpIDRestoreGapsFromSCR: $result"
    }
    after 1000 
    APSMpStep "Moving gaps to setpoints"
    if $pem {
        if [catch {APSIDStaggerGaps -IDList $deviceList -returnGaps 0 -interval $closeInterval} result] {
            APSMpReturn error "APSMpIDRestoreGaps(10): error in stagger gaps: $result"
        }
    } else {
        #can not run in parallel without pem
        set scuList ""
        set otherGaps ""
        set moveID01us 0
        foreach ID $deviceList {
            if {$ID=="ID01ds" || $ID=="ID06ds" || $ID=="ID07ds"} {
                lappend scuList $ID
            } elseif {$ID=="ID01us"} {
                set moveID01us 1
            } else {
                lappend otherGaps $ID
            }
        }
        if [llength $otherGaps] {
            if [catch {APSIDMoveRegularGaps -IDList $otherGaps -interval $closeInterval} result] {
                return -code error "APSSRMoveIDGaps13: $result"
            }
        }
        if [llength $scuList] {
            foreach ID $scuList {
                if [catch {exec cavget -list=$ID:GapSet -pend=20 -printErrors} value] {
                    return -code error "APSSRMoveIDGaps14: Error reading $ID:GapSet: $value"
                }
                if [catch {APSSRMoveSCUID -ID $ID -moveTo $value} result] {
                    return -code error "APSSRMoveIDGaps15: error moving SCU $ID: $result"
                }
            }
        }
        if $moveID01us {
            if [catch {exec cavget -list=ID01us:GapSet -pend=20 -printErrors} value] {
                return -code error "APSSRMoveIDGaps16: Error reading ID01us:GapSet: $value"
            }
            if [catch {APSSRMoveID01US -moveTo $value} result] {
                return -code error "APSSRMoveIDGaps17: error moving ID01us gap: $result"
            }
        }
    }
    after 1000 
    #check if gaps are moving
    APSMpStep "Waiting for ID gaps stop moving. (it may take several minutes, please be patient.)"
    if {[catch {APSMpCheckAndWaitForIDs -deviceList $deviceList} results]} {
        if {[APSPEMTKDialog .warningDialog -text "APSMpIDRestoreGapsFromSCR: Problem occurred while waiting restoring ID gaps\n$results"] == 1} {
            APSMpReturn error "APSMpIDRestoreGapsFromSCR: $results"
        }
    }
    APSMpReturn ok
}

proc APSMpCheckAndWaitForIDs {args} {
    #wait for ID gaps stop moving
    set deviceList ""
    set timeout 500
    set tolerance 0.1
    APSStrictParseArguments {deviceList tolerance timeout}
    
    if ![llength $deviceList] {
       APSMpReturn ok
    }
    set time0 [expr [clock seconds] + $timeout]
    APSMpStep "APSMpCheckAndWaitForIDs: checking if gaps done moving.."
  
    set errorMsg ""
    set deviceList1 $deviceList
    while {[clock seconds]<$time0} {
        if [catch {exec cavget -list=[join $deviceList ,] -list=:MotorDriveStatus -numerical -pend=30 -printErrors} valList] {
            APSMpReturn error "Error(APSMpCheckAndWaitForIDs1a): $valList"
        }
        set msg "" 
        set IDList $deviceList
        foreach ID $deviceList val $valList {
            if [catch {exec cavget -list=$ID -list=:Gap,:GapSet -pend=30  -printErrors} results] {
                APSMpReturn error "Error(APSMpCheckAndWaitForIDs1b): $results"
            }
            set gap [lindex $results 0]
            set gapset [lindex $results 1]
            set diff [expr abs($gap-$gapset)]
            if {$diff<=$tolerance} {
                #remove it from checking.
                set index [lsearch $IDList $ID]
                set IDList [lreplace $IDList $index $index]
            } else  {
                if !$val {
                    if {$diff>$tolerance} {
                        append msg "$ID device is off, can not move $ID\n"
                    } 
                }
            } 
        }
        if ![llength $IDList] {
            APSMpReturn ok
        }
        set deviceList $IDList
        if [string length $msg] {
            APSMpReturn error "Error(APSMpCheckAndWaitForIDs1c): aborted because\n$msg." 
        }
        if [catch {exec cavget -list=[join $deviceList ,] \
                       -list=:Message1.VAL -pend=30 -printErrors} msgList] {
            APSMpReturn error "Error(APSMpCheckAndWaitForIDs1): $msgList"
        }
        set doneMoving 1
        set errorMsg ""
        set restart 0
        foreach gap $deviceList msg $msgList {
            if {$gap=="ID01ds" || $gap=="ID06ds"} {
                if [regexp {OK} $msg] {
                    if [catch {exec cavget -list=$gap -list=:Gap,:GapSet \
                                 -pendIO=30 -printErrors} val0List] {
                        APSMpReturn error "Error(APSMpCheckAndWaitForIDs3): $val0List"
                    }
                    set gapVal [lindex $val0List 0]
                    set gapsetVal [lindex $val0List 1]
                    set diff [expr abs($gapVal - $gapsetVal)]
                    if $diff>$tolerance {
                        set restart 1
                        APSMpStep "$gap is moving ..."
                        set doneMoving 0
                    }
                } else {
                    append errorMsg "$gap $msg"
                }
                continue
            }
            if {[string compare $msg "Device At Destination"]==0} {
                continue
            }
            if {[string compare $msg "Device Started"]==0} {
                set doneMoving 0
                continue
            }
            
            if {[string compare $msg "Device Stopped!!"]==0} {
                set answer [APSMultipleChoice [APSUniqueName .] -modal 1 \
                                -question "$gap was stopped before reaching the destination, would you like to abort the pem or restart moving the gap?" \
                                -returnList {1 0} \
                                -labelList {Abort Restart}]
                if $answer { 
                    APSMpReturn error "$gap was stopped before reaching the destination!"
                } else {
                    set restart 1
                    APSMpStep "$gap $msg, press Start button again."
                    if [catch {exec cavput -list=$gap:Start.VAL=1 -pend=10} result] {
                       APSMpReturn error "Error(APSMpCheckAndWaitForIDs2): $result" 
                    }
                    set doneMoving 0
                }
            } elseif {[string compare $msg "Device Recovered!"]==0} {
                if [catch {exec cavget -list=$gap -list=:Gap,:GapSet \
                               -pendIO=30 -printErrors} val0List] {
                    APSMpReturn error "Error(APSMpCheckAndWaitForIDs3): $val0List"
                }
                set gapVal [lindex $val0List 0]
                set gapsetVal [lindex $val0List 1]
                set diff [expr abs($gapVal - $gapsetVal)]
                if $diff>$tolerance {
                    set restart 1
                    APSMpStep "$gap $msg, press Start button again."
                    if [catch {exec cavput -list=$gap:Start.VAL=1 -pend=10} result] {
                        APSMpReturn error "Error(APSMpCheckAndWaitForIDs4): $result" 
                    }
                    set doneMoving 0
                }
            } else { 
                append errorMsg "$gap $msg\n" 
            }
        }
        if $restart {
            APSMpStep "Waiting for gaps to stop moving."
            set time0 [expr $time0 + $timeout]
        }
        if $doneMoving {
            break
        }
        APSWaitWithUpdate -waitSeconds 1
    }
     
    if [catch {exec cavget -list=[join $deviceList1 ,] -list=:GapSet -pend=30 -printErrors } setList] {
        APSMpReturn error "Error(APSMpCheckAndWaitForIDs5): $setList"
    }
    
    if [catch {exec cavget -list=[join $deviceList1 ,] -list=:Gap -pend=30 -printErrors } valList] {
        APSMpReturn error "Error(APSMpCheckAndWaitForIDs6): $valList"
    }
    
    foreach gap $deviceList1 val $valList set $setList {
        set diff [format %.3f [expr abs($set-$val)]]
        if {$diff>$tolerance} {
            append errorMsg "\n$gap setpoint=$set mm, readback=$val mm,  difference=$diff"
        }
    }
    
    if [string length $errorMsg] {
       APSMpReturn  error "${errorMsg}\n\nThe above devices had problem, please call related person for help."
    }
    APSMpReturn ok
}

proc TestCheckIDPem {} {
    set deviceList [APSIDGetDeviceList]
    if {[catch {APSMpCheckAndWaitForIDs -deviceList $deviceList -tolerance 0.5 } results]} {
        if {[APSPEMTKDialog .warningDialog -text "APSMpIDRestoreGapsFromSCR: Problem occurred while waiting restoring ID gaps\n$results"] == 1} {
            APSMpReturn error "APSMpIDRestoreGapsFromSCR: $results"
        }
    }
    APSMpReturn ok
}

proc APSCloseID35Shutter {} {
    if [catch {exec cavget -list=EPS:35:ID:PS2:POSITION -printErrors -pend=10} shutter] {
        return -code error "APSMpSRCollectGapFFTable(25a): Error in reading ID35 shutter status: $shutter."
    }
    if {$shutter=="Open"} {
        set answer [APSMultipleChoice .info -modal 1 -name "ID 35 shutter is open" \
                      -question "Warning: ID35 shutter is open and you're attempting to close the gap below 20mm: chose one\na)close shutter and proceed\nb)Yes I know the shutter is open and I know what I'm doing, so blunderahead by pressing the \"Continue\" button" \
                      -labelList {Close-shutter-and-proceed Continue} \
                      -returnList {Close Continue} ]
        if {$answer=="Close"} {
            #1 closed, 2 open, 0, moving, 3, position error
            if [catch {exec cavput -list=S35ID:PS2CloseC.VAL=1 -pend=10} result] {
                return -code error "APSMpSRCollectGapFFTable(25a): Error in closing ID35 shutter: $result."
            }
            after 2000
        }
    } elseif {$shutter=="Closed"} {
        return
    } else {
        return -code error "APSMpSRCollectGapFFTable(25b): ID35 shutter is in wrong place: $shutter."
    }
}


proc APSMpRebootCPUIOCInfo {} {
    return "After studies of CPU, reboot the CPU ioc and verifying critical operational modes before handed over to users."
}

proc APSMpRebootCPUIOC {} {
    global execMode
    APSMpStep init -promptDialog "APSMpPromptInitDialog"
    
    set monFile /home/helios/oagData/sr/IDs/CPU/CPU-reboot.mon
    set tmpRoot /tmp/[APSTmpString].cpu
    
    APSMpStep "Step 1: Set the main coil currents to zero amps."
    if [catch {exec cavput -list=ID04b:set_H_coil.VAL=0,ID04b:set_V_coil.VAL=0 } result] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to set the H, V coil current to 0: $result"
    }
    APSMpStep "Step 2: Skip the AFG reset procedures."
    
    APSMpStep "Step 3: Have one of the operators reboot the IOC using iocConsol iocid04b command."
    APSInfoWindow .info -name "reboot ioc." -modal 1\
      -width 50 -infoMessage "Have one of the operators reboot the IOC using iocConsol iocid04b command."

    APSMpStep "Step 4: Perform a hard reset using ctrl-yyy"
    APSInfoWindow .info -name "Preform reset." -modal 1\
      -width 50 -infoMessage "Have a operator perform a hard reset using ctril-yyy."
    
    APSMpStep "Step 5: set the access security mode to User."
    
    if [catch {exec cavput -list=ID04b:AccessSecurity.VAL=User -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to set the access security mode to user: $result"
    }
    
    APSMpStep "Step 6: verify that, in CPU Main Control Screen, the CM/CCW half-period is set to 2.00 sec."
    
    if [catch {exec cavget -list=ID04b:timer.VAL -printErrors -pend=10} hperiod] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to read the CM/CCW half-period: $hperiod"
    }
    set halfPeriod 2.0
    if {$hperiod!=$halfPeriod} {
        if [catch {exec cavput -list=ID04b:timer.VAL=$halfPeriod -pend=10} hperiod] {
            APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to set the CM/CCW half-period: $hperiod"
        }
    }
    
    APSMpStep "Step 7: verify that in the CPU Correct Files screen, the up, down and user (ramp) limit is set to 0.500s/step."
    
    if [catch {exec cavput -list=ID04b:rate_up.VAL=0.5,ID04b:rate_down.VAL=0.5,ID04b:rate_user.VAL=0.5  \
                 -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to set the up, down and user limit: $result"
    }
    
    APSMpStep "Step 8: set the operation mode to AC CW/CCW"
   
    if [catch {exec cavput -list=ID04b:DesiredMode.VAL=4 -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to set the operatonal mode: $result"
    }
    after 2000
    
    APSMpStep "Step 9: Set the trigger select to Extenal"
   
    if [catch {exec cavput -list=ID04b:TriggerSelect.VAL=1 -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to set the trigger selection: $result"
    }
    
    APSMpStep "Step 10: Setup a screen chart to monitor the PVs."
    exec StripTool /home/helios/SHANG/cpu_corrector.stp &
    exec StripTool /home/helios/SHANG/cpu_current.stp &
    
    
    APSMpStep "Step 11: Turn on the main power supply."
    if [catch {exec cavput -list=ID04b:on_off.VAL=1 -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to turn on the main power supply: $result"
    }
    APSWaitWithUpdate -waitSeconds 20 -update 1
    while {1} {
        if [catch {APScavget -list=ID04b:Ready -pend=10 -printErrors} ready] {
            APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to read CPU ready state: $ready"
        }
        if {$ready!=1} {
            after 1000
        } else {
            break
        }
    }
    APSMpStep "Step 12: Ramp the energy t0 0.385KeV\n"
    
    if [catch {exec cavput -list=ID04b:set_energy.VAL=0.385 -pend=10} energy] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to set the energy: $energy"
    }
    set monID [exec sddsmonitor $monFile $tmpRoot.cpu \
			   -interval=0.2,seconds -time=20,minutes &]
    after 10000
    
    while {1} {
        if [catch {APScavget -list=ID04b:feedback.VAL -pend=10 -printErrors} ready] {
            APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to read feedback state: $ready"
        }
        if {$ready!="Ready"} {
            after 1000
        } else {
            break
        }
    }

    APSMpStep "Step 12c: set the trigger select switch to external."
    if [catch {exec cavput -list=ID04b:TriggerSelect.VAL=External -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC -- unable to set the trigger to external: $result"
    }
    
    APSMpStep "Step 13: set the operational mode to \"CW,RCP\""
    
    if [catch {exec cavput -list=ID04b:DesiredMode.VAL=0 -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC -- unable to set the operational mode to CW,RCP: $result"
    }
   after 10000
    while {1} {
        if [catch {APScavget -list=ID04b:feedback.VAL -pend=10 -printErrors} ready] {
            APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to read feedback state: $ready"
        }
        if {$ready!="Ready"} {
            after 1000
        } else {
            break
        }
    }
    
    APSMpStep "Step 14: Set the operation mode to \"CCW,LCP\"\n"
    
    if [catch {exec cavput -list=ID04b:DesiredMode.VAL=1 -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC -- unable to set the operational mode to CCW,RCP: $result"
    }
    after 10000
    while {1} {
        if [catch {APScavget -list=ID04b:feedback.VAL -pend=10 -printErrors} ready] {
            APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to read feedback state: $ready"
        }
        if {$ready!="Ready"} {
            after 1000
        } else {
            break
        }
    }
    
    APSMpStep "Step 15: Set the operation mode to \"V\""
  
    if [catch {exec cavput -list=ID04b:DesiredMode.VAL=2 -pend=10} result] {
        APSMpReturn error "APSMpRebootCPUIOC -- unable to set the operational mode to V: $result"
    }
    after 2000
    APSMpStep "Step 16a: Ramp the energy to 0.71 keV"
    if [catch {exec cavput -list=ID04b:set_energy.VAL=0.71 -pend=10 } result] {
        APSMpReturn error "APSMpCPUIOCReboot: unable to set energy to 0.71: $result"
    }
    after 2000
    while {1} {
	if [catch {APScavget -list=ID04b:ActualMode -pend=10} mode] {
	    APSMpReturn error "APSMpCPUIOCReboot: unable to read CPU actual mode: $mode"
	}
	if {$mode!="V"} {
	    after 1000
	} else {
	    break
	}
    }
    APSMpStep "Step 16: Set H coil to 1600A"
    if [catch {exec cavput -list=ID04b:set_H_coil.VAL=1600 -pend=10} result] {
	 APSMpReturn error "APSMpCPUIOCReboot: unable to set h coil to 1600: $result"
    }
    after 5000
    while {1} {
        if [catch {APScavget -list=ID04b:feedback.VAL -pend=10 -printErrors} ready] {
            APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to read feedback state: $ready"
        }
        if {$ready!="Ready" } {
            after 1000
        } else {
            break
        }
    }
    
    
    APSMpStep "Step 17: .Set the operation mode to \"H\""
   
    if [catch {exec cavput -list=ID04b:DesiredMode.VAL=3 -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC -- unable to set the operational mode to H: $result"
    }
    after 2000
    APSMpStep "Step 18: Ramp the energy to 0.71 keV"
    if [catch {exec cavput -list=ID04b:set_energy.VAL=0.71 -pend=10 } result] {
        APSMpReturn error "APSMpCPUIOCReboot: unable to set energy to 0.71: $result"
    }
    
    after 10000
    while {1} {
        if [catch {APScavget -list=ID04b:feedback.VAL -pend=10 -printErrors} ready] {
            APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to read feedback state: $ready"
        }
        if {$ready!="Ready" } {
            after 1000
        } else {
            break
        }
    }
    
    APSMpStep "Step 19: Set the operation mode to \"CW/CCW\""
    if [catch {exec cavput -list=ID04b:DesiredMode.VAL=4 -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC -- unable to set the operational mode to H: $result"
    }
    after 10000
    while {1} {
        if [catch {APScavget -list=ID04b:feedback.VAL -pend=10 -printErrors} ready] {
            APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to read feedback state: $ready"
        }
        if {$ready!="Ready"} {
            after 1000
        } else {
            break
        }
    }
    
    APSMpStep "Step 20: set the V coil current to 0."
    if [catch {exec cavput -list=ID04b:set_V_coil.VAL=0 -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to set the V coil current to 0: $result"
    }
    while {1} {
        if [catch {APScavget -list=ID04b:feedback.VAL -pend=10 -printErrors} ready] {
            APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to read feedback state: $ready"
        }
        if {$ready!="Ready"} {
            after 1000
        } else {
            break
        }
    }
    exec kill -9 $monID
    
    APSMpStep "Step 21: Turn off the main power supply by clicking the \"Off\" button."
   
    if [catch {exec cavput -list=ID04b:on_off.VAL=0 -pend=10 } result] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- unable to turn off the power supply: $result"
    }
    set filename $tmpRoot.cpu
   
    APSMpStep "Step 22: Check the correction current chart that all the readouts are smooth and no noise peaks reach 0.1 A.\n"
    if [catch {APSProcessCPUCorrector -filename $filename -halfPeriod $halfPeriod} printFile] {
        APSMpReturn error "APSMpRebootCPUIOC(Error) -- error in process CPU correctors: $printFile"
    }
    if [string length $printFile] {
        APSFileDisplayWindow [APSUniqueName .] -fileName $printFile -modal 1 \
          -width 80 -printCommand "enscript -r"
        APSMpReturn error "Some correctors have more than 0.3A difference from the reference. Please check the different and plot, and make sure it is ok; otherwise, you will need re-run the pem."
    } else {
        APSInfoWindow .info -name "Done" -modal 1\
          -width 50 -infoMessage "CPU IOC reboot done successfully."
    }
    APSMpReturn ok
}




proc APSProcessCPUCorrector {args} {
    set filename ""
    set tolerance 0.3
    set lowLimit 25
    APSParseArguments {filename lowLimit tolerance}

    global CPUPlotOpt ""
    set tmpRoot /tmp/[APSTmpString]CPU
    catch { exec sddsplot -col=Time,I* -grap=line,vary -tick=xtime $filename & }
    
    set CPUPlotOpt ""
    
    if [catch {exec sddsbreak $filename -pipe=out -change=ID4:CPU:ActualMode  \
                 | tee /tmp/tta \
                 | sddsprocess -pipe -process,ID4:CPU:ActualMode,first,Mode \
                 -process=Iv,max,IvMax \
                 | tee /tmp/ttb \
                 | sddssplit -pipe=in -root=$tmpRoot -digits=3 } result] {
        return -code error "APSProcessCPUCorrector(1): $result"
    }
   
    set fileList [lsort [glob -nocomplain ${tmpRoot}*.sdds]]
    
    set printFiles ""
    set modeList {CW CCW V H AC}
    set index 0
    foreach file $fileList {
	set mode [format %.0f [exec sdds2stream -par=Mode $file]]
        set IvMax [exec sdds2stream -par=IvMax $file]
        if {($index==0 && $mode!=4) || ($mode==4 && $IvMax<100)} {
            #found the first AC mode, where mode=4, and IvMax>100
            continue
        }
        switch $mode {
            4 {
                if {$index==0} {
                    set vol 0.385
                } else {
                    set vol 0.71
                }
                APSMpStep "Process AC mode at $vol KeV."
                if [catch {APSProcessCPUACMode -filename $file -voltage $vol -tolerance $tolerance} result] {
                    return -code error "APSProcessCPUCorrector(2) -- process AC mode: $result"
                }
                if [string length $result] {
                    lappend printFiles $result
                } else {
                    APSMpStep "No difference found for AC mode at $vol KeV."
                }
            }
            default {
		set mode [lindex $modeList $mode]
                APSMpStep "Process $mode..."
                if [catch {ProcessCPUDCData -filename $file -mode $mode -tolerance $tolerance} result] {
                    return -code error "APSProcessCPUCorrector(3) -- process DC mode: $result"
                }
                if [string length $result] {
                    lappend printFiles $result
                } else {
                    APSMpStep "No difference found for DC $mode mode."
                }
            }
        }
        incr index
    }
    set printFile ""
    if [llength $printFiles]>1 {
        set printFile $tmpRoot.print
        eval exec cat $printFiles > $printFile
    } elseif {[llength $printFiles]==1} {
        set printFile $printFiles
    }
    
    if [llength $printFiles] {
        catch {eval exec sddsplot -axes=x -sep=2  $CPUPlotOpt &}
        return $printFile
    }
}

proc APSProcessCPUACMode {args} {
    set filename ""
    set voltage ""
    set tolerance 0.1
    set halfPeriod 3
    APSParseArguments {filename voltage tolerance halfPeriod}
    set tmpRoot /tmp/[APSTmpString]AC
    global CPUPlotOpt
    set gap [expr $halfPeriod - 0.5]
    if [catch {exec sddsprocess $filename "-test=col,Iv 10 >" -pipe=out \
                 | sddsbreak -pipe -gapin=Step,amount=1.5 \
                 | sddsprocess -pipe -clip=2,0 -nowarnings \
                 | sddsprocess -pipe -clip=1,0,invert -nowarnings \
                 | sddscombine -pipe=in $tmpRoot.pos -merge 
        exec sddsprocess $filename -pipe=out "-test=col,Iv -10 <" \
                 | sddsbreak -pipe -gapin=Step,amount=1.5 \
                 | sddsprocess -pipe -clip=5,0 -clip=0,1 -nowarnings \
                 | sddsprocess -pipe -clip=1,0,invert -nowarnings \
                 | sddscombine -pipe -merge \
                 | sddsprocess -pipe=in $tmpRoot.neg "-define=col,IvAbs,Iv abs"  \
             } result] {
        return -code error "APSProcessCPUACMode(1): error in processing file: $result"
    }
    set mainDir /home/helios/oagData/
    set corrList {Vcorr2 Hcorr2 Hcorr1 Vcorr1 NormalQuad RotatedOct RotatedQuad}
    for {set i 1} {$i<=7} {incr i} {
        set col [lindex $corrList [expr $i-1]]
        if [catch {exec cavget -list=ID04b:corrFile_${i}.VAL -pend=20 -printErrors} file] {
            return -code error "APSProcessCPUACMode(2): unable to read ID04b:corrFile_${i}.VAL:$file"
        }
        #special case for skewOct, skewQua, should remove it in the future
        
        if [catch {exec sddsconvert $mainDir/$file -pipe=out -del=par,DCPos,DCNeg \
                     | sddsprocess -pipe \
                     -proc=CurrentPos,last,DCPos -proc=CurrentNeg,last,DCNeg \
                     | sddscollapse -pipe \
                     | tee $tmpRoot.$i.cur \
                     | sddsinterp -pipe=in $tmpRoot.$i.pos \
                     -fileValues=$tmpRoot.pos,column=Iv \
                     -col=MainCurrent,DCPos } result] {
            return -code error "APSProcessCPUACMode(3): $result"
        }
        if [catch {exec sddsinterp $tmpRoot.$i.cur $tmpRoot.$i.neg \
                     -fileValues=$tmpRoot.neg,column=IvAbs \
                     -col=MainCurrent,DCNeg } result] {
            return -code error "APSProcessCPUACMode(4): $result"
        }
        if [catch {exec sddsxref $tmpRoot.pos $tmpRoot.$i.pos -rename=col,DCPos=$col $tmpRoot.pos1 -nowarnings
            exec sddsxref $tmpRoot.neg $tmpRoot.$i.neg -rename=col,DCNeg=$col $tmpRoot.neg1 -nowarnings} result] {
            return -code error "APSProcessCPUACMode(5): $result"
        }
        exec mv $tmpRoot.pos1 $tmpRoot.pos
        exec mv $tmpRoot.neg1 $tmpRoot.neg
    }
    if {0} {
    exec sddsplot $tmpRoot.pos -layout=2,4 -topline=AC "-title=Positive current" \
      -sep=2 -axes=x  \
      -col=Iv,*Hcorr1 -grap=sym,vary=sub -leg  \
      -col=Iv,*Hcorr2 -grap=sym,vary=sub -leg  \
      -col=Iv,*Vcorr1 -grap=sym,vary=sub -leg  \
      -col=Iv,*Vcorr2 -grap=sym,vary=sub -leg  \
      -col=Iv,*NormalQuad -grap=sym,vary=sub -leg  \
      -col=Iv,*RotatedOct -grap=sym,vary=sub -leg  \
      -col=Iv,*RotatedQuad -grap=sym,vary=sub -leg &
    
    exec sddsplot $tmpRoot.neg -layout=2,4 -topline=AC "-title=Negative current" \
       -axes=x -sep=2  \
      -col=Iv,*Hcorr1 -grap=sym,vary=sub -leg  \
      -col=Iv,*Hcorr2 -grap=sym,vary=sub -leg  \
      -col=Iv,*Vcorr1 -grap=sym,vary=sub -leg  \
      -col=Iv,*Vcorr2 -grap=sym,vary=sub -leg  \
      -col=Iv,*NormalQuad -grap=sym,vary=sub -leg  \
      -col=Iv,*RotatedOct -grap=sym,vary=sub -leg  \
      -col=Iv,*RotatedQuad -grap=sym,vary=sub -leg &
    
    }
    
    set printFiles ""
    
    foreach corr $corrList {
        foreach type {pos neg} comm {Positive Negative} {
            if [catch {exec sddsprocess $tmpRoot.$type -pipe=out \
                         "-define=col,Diff,ID4:CPU:$corr $corr - abs" \
                         | sddsprocess -pipe=in $tmpRoot.$corr.$type "-test=col,Diff $tolerance >" -nowarnings} result] {
                return -code error "APSProcessCPUACMode(6): $result"
            }
            set rows [exec sdds2stream -rows=bar $tmpRoot.$corr.$type]
            if {$rows} {
                if [catch {exec sddsprintout $tmpRoot.$corr.$type $tmpRoot.$corr.$type.print \
                             "-title=$corr AC mode at $voltage KeV has bigger than 0.1A difference from the reference." \
                             -col=Iv,format=%15.3f -col=ID4:CPU:$corr,format=%15.3f -col=$corr,format=%15.3f \
                             -col=Diff,format=%15.3f } result] {
                    return -code error "APSProcessCPUACMode(7): $result"
                }
                lappend printFiles $tmpRoot.$corr.$type.print
                lappend CPUPlotOpt  -col=Iv,*${corr} -grap=sym,vary=sub -leg "-title=$comm current" "-topline=AC ($voltage KeV)" $tmpRoot.$type
            }
        }
    }
    APSMpStep "$printFiles"
    if [llength $printFiles]==1 {
        set printFile $printFiles
    } elseif {[llength $printFiles]>1} {
        set printFile $tmpRoot.print
        eval exec cat $printFiles > $printFile
    } else {
        return
    }
    puts $printFile
    return $printFile
}

proc ProcessCPUDCData {args} {
    set filename ""
    set mode "" 
    set tolerance 0.3
    APSParseArguments {filename mode tolerance}
    set mainDir /home/helios/oagData/
    set tmpRoot /tmp/[APSTmpString]DC

    global CPUPlotOpt
    if {$mode=="H"} {
        set current Iv
    } else {
        set current Ih
    }
    if [catch {exec sddsprocess $filename $tmpRoot \
                 -sparse=5 \
                 "-redefine=col,I,$current abs" } result] {
        return -code error "ProcessCPUDCData(1): $result"
    }
    set corrList {Vcorr2 Hcorr2 Hcorr1 Vcorr1 NormalQuad RotatedOct RotatedQuad}
    if [catch {exec cavget -list=ID04b:corrFile.VAL -pend=10 -printErrors} refFile] {
        return -code error "ProcessCPUDCData(2): $refFile"
    }
    
    if [catch {exec sddsprocess $mainDir/$refFile -pipe=out -match=par,Mode=$mode \
                 "-redefine=col,I,I abs" \
                 | sddsinterp -pipe=in $tmpRoot.1 -fileValues=$tmpRoot,column=I \
                 -col=I,*} result] {
        return -code error "ProcessCPUDCData(3): $result"
    }
    
    if [catch {exec sddsxref $tmpRoot $tmpRoot.1 $tmpRoot.$mode -take=[join $corrList ,] -transfer=par,Mode } result] {
        return -code error "ProcessCPUDCData(4): $result"
    }
    if {0} {
    exec sddsplot $tmpRoot.$mode -topline=@Mode \
      -layout=4,2 -sep=2 -axes=x \
      -col=$current,*Hcorr1 -grap=sym,vary=sub -leg \
      -col=$current,*Hcorr2 -grap=sym,vary=sub -leg  \
      -col=$current,*Vcorr1 -grap=sym,vary=sub -leg  \
      -col=$current,*Vcorr2 -grap=sym,vary=sub -leg  \
      -col=$current,*NormalQuad -grap=sym,vary=sub -leg  \
      -col=$current,*RotatedOct -grap=sym,vary=sub -leg  \
      -col=$current,*RotatedQuad -grap=sym,vary=sub -leg &
    }
    
    set printFiles ""
    foreach corr $corrList {
        if [catch {exec sddsprocess $tmpRoot.$mode -pipe=out \
                     "-define=col,Diff,ID4:CPU:$corr $corr - abs" \
                     | sddsprocess -pipe=in $tmpRoot.$corr "-test=col,Diff $tolerance >" -nowarnings} result] {
            return -code error "APSProcessCPUDCMode(5): $result"
        }
        set rows [exec sdds2stream -rows=bar $tmpRoot.$corr]
        if {$rows} {
            if [catch {exec sddsprintout $tmpRoot.$corr $tmpRoot.$corr.print \
                         "-title=$corr $mode DC mode has bigger than 0.1A difference from the reference." \
                         -col=$current,format=%15.3f -col=ID4:CPU:$corr,format=%10.3f -col=$corr,format=%15.3f \
                         -col=Diff,format=%15.3f } result] {
                return -code error "APSProcessCPUDCMode(6): $result"
            }
            lappend printFiles $tmpRoot.$corr.print
            lappend CPUPlotOpt -col=$current,*${corr} -grap=sym,vary=sub -leg -topline=$mode $tmpRoot.$mode
        }
    }
    if [llength $printFiles]==1 {
        set printFile $printFiles
    } elseif {[llength $printFiles]>1} {
        set printFile $tmpRoot.print
        eval exec cat $printFiles > $printFile
    } else {
        return
    }
    
    return $printFile
}

proc APSSetupSRCerenkovDector {args} {
    set detectorList [exec sdds2stream -col=Sector /home/helios/oagData/sr/cerenkov/inputFiles/cherenkovSetup.sdds]
    set filename ""
    set statusCallback ""
    APSParseArguments {detectorList filename statusCallback}

    if ![string length $filename] {
        #find the last setup file
        set filename /home/helios/PHOTODIA/DeviceData/SR/Cherenkov/cherenkovSetup.sdds
    }
    if ![file exist $filename] {
        return -code error "APSSetupSRCerenkovDector(1): setup file $filename does not exist!"
    }
    set tmpRoot /tmp/[APSTmpString]
    foreach detector $detectorList {
        set site "${detector}"
        set board [APSGetCherenkovBoard -detector $detector]
        if [catch {exec sddsprocess $filename $tmpRoot -match=col,Site=$site } result] {
            APSMpReturn error "APSSetupSRCerenkovDector(2): error in finding $site in $filename: $result"
        }
        set targetPMTVolt [format %0.1f [exec sdds2stream $tmpRoot -col=targetPMTVolt]]
        set Adc0AIOffset  [format %0.0f [exec sdds2stream $tmpRoot -colum=Adc0AIOffset]]
        set Adc1AIOffset  [format %0.0f [exec sdds2stream $tmpRoot -column=Adc1AIOffset]]
        set Discriminator [format %0.3f [exec sdds2stream $tmpRoot  -column=Discriminator]]
        if [catch { exec /home/helios/oagData/sr/cerenkov/scripts/setupCherenkovOneSector -sector $board \
                      -integratorOffset0 $Adc0AIOffset -integratorOffset1 $Adc1AIOffset -pmtHV $targetPMTVolt \
                      -discriminator $Discriminator \
                  } result] {
            APSMpReturn error "APSSetupSRCerenkovDector(3): error in setup $board: $result"
        }
        APSMpStep "APSStupCherenkovDetector: Complete initializing Cherenkov detector boards at $board."
        if [string length $statusCallback] {
            eval $statusCallback {"APSStupCherenkovDetector: Complete initializing Cherenkov detector boards at $board."}
        }
    }
    APSMpReturn ok
}

proc APSGetCherenkovBoard {args} {
    set detector ""
    APSParseArguments {detector}

    set detectorList3 { S4A S4B S4C S4D S4E S36a S36b S36c S36d S36e }
    set boardList3    { S3  S5  S6  S7  S8  S36a S36a S36a S36a S36a }
    set detectorIndex [lsearch $detectorList3 $detector]
    if { $detectorIndex > -1 } {
        set board [lindex $boardList3 $detectorIndex]
    } else {
        set board $detector
    }
    return $board
}

proc APSMpIEXInitializeInfo {} {
    return "Prepare IEX for next user operation period by:\n1. Run degaussing and conditioning of the magnet. If you select degauss, then condition will be selected automatically.\n2. Reset IEX parameters to default values."
}

proc UpdateIEXSelection {args} {
    global APSMpIEXInitialize
    if $APSMpIEXInitialize(reset) {
        set APSMpIEXInitialize(degauss) 0
        set APSMpIEXInitialize(condition) 0
    }
    if {$APSMpIEXInitialize(degauss) || $APSMpIEXInitialize(condition)} {
        set APSMpIEXInitialize(reset) 0	
    }
    if $APSMpIEXInitialize(degauss) {
        set APSMpIEXInitialize(condition) 1
    }
}

proc APSMpIEXInitializeInitDialog {frame} {
    global APSMpIEXInitialize
    APSCheckButtonFrame .cb -parent $frame -label "check deguass or condition" \
      -limitPerRow 8 -buttonList {reset degauss condition} \
      -variableList "APSMpIEXInitialize(reset) APSMpIEXInitialize(degauss) APSMpIEXInitialize(condition)" \
      -commandList {UpdateIEXSelection UpdateIEXSelection UpdateIEXSelection}
}

proc APSMpIEXInitialize {args} {
    global APSMpIEXInitialize
    set APSMpIEXInitialize(reset) 1
    set APSMpIEXInitialize(degauss) 0
    set APSMpIEXInitialize(condition) 0
    
    APSMpStep init -promptDialog "APSMpIEXInitializeInitDialog" \
      -desc "check degauss or condition"

    catch {exec cavput -list=ID29:Main_on_off.VAL=1}
    if {[set a [exec cavget -list=ID29:SaveDioWrite.VAL -pend=10]] != 8185} {
	APSMpReturn error "IEX status is not correct. Turn off IEX or Ask expert for help.\n Last DIO Write = $a"
    }

    APSMpStep "Step 0: Reset IEX parameters"
    if [catch {
	exec caput ID29:BxStepLimit 2
        exec caput ID29:ByStepLimit 2
#        exec caput ID29:QuasiRatio.RVAL 100
        exec caput ID29:dVSetpt 10
        exec caput ID29:dTSetpt 20
        exec caput ID29:dHSetpt 10
        exec caput ID29:RampWaitTime 1.5
	exec caput ID29:PolarityWaitTime 1.5
        exec caput ID29:PolarityResetSeq.PROC 1
        after 2000
        exec caput ID29:SetPSLocRem 1
        after 1000
        exec caput ID29:SetPSLocRem 0
        exec caput ID29:ReadSDDSfile.PROC 1
        exec caput ID29:ZeroMult.PROC 1
        after 1000
        exec caput ID29:MP2I.PROC 1
        after 1000
        exec caput ID29:SetOutputSeq.PROC 1
        after 1000
        exec caput ID29:CorrRstSeq.PROC 1 
	after 1000
	exec caput ID29:RstIntlckSeq.PROC 1
    } result] {
        APSMpReturn -error "APSMpIEXInitialize1: error in reset IEX parameters: $result"
    }    
    after 5000

    APSMpStep "Step 1: Check IEX PS status"
    set PScheck 0
    set PScheckErr ""
    set mainPS [exec cavget -list=ID29:BxRdbk.VAL,ID29:ByRdbk.VAL,ID29:BxqRdbk,ID29:ByqRdbk]
    set mainPSName "Bx By Bxq Byq"
    set corrPS [exec cavget -list=ID29:CorrRdbk -list=UST,USB,USQ1,USQ2,USQ3,USQ4,DST,DSB,DSQ1,DSQ2,DSQ3,DSQ4]
    set corrPSName "UST USB USQ1 USQ2 USQ3 USQ4 DST DSB DSQ1 DSQ2 DSQ3 DSQ4"
    set earthPS [exec cavget -list=ID29:CorrRdbkEarth.VAL]
    if {[expr abs($earthPS + 1.25)]>0.25} {
	set PScheck 1
	lappend PScheckErr "earth"
    }
    foreach ps $mainPS name $mainPSName {
	if {[expr abs($ps)]>0.5} {
	    set PScheck 1
	    lappend PScheckErr $name
	}
    }
    foreach ps $corrPS name $corrPSName {
	if {[expr abs($ps)]>0.02} {
	    set PScheck 1
	    lappend PScheckErr $name
	}
    }
    if $PScheck {
	APSMpReturn error "IEX PS has wrong read backs.\nList=$PScheckErr"
    }

    APSMpStep "Step 2: Check IEX interlock status"
    set intertLockCheck 0
    set intertLockCheckErr ""
    set interLockPV "ID29:CorrectorReset ID29:MainOnOff"
    set interLockPV [concat $interLockPV "ID29:BxPolarity ID29:ByPolarity ID29:BxqPolarity ID29:ByqPolarity ID29:PolarityReset"]
    set interLockPV [concat $interLockPV "ID29:MainPS1OutEn ID29:MainPS2OutEn ID29:MainPS3OutEn ID29:MainPS4OutEn"]
    foreach inter $interLockPV {
	if {![lindex [exec caget -n $inter] 1]} {
	    set intertLockCheck 1
	    lappend intertLockCheckErr $inter
	}
    }
    if {[lindex [exec caget -n ID29:CorrectorInh] 1] || [lindex [exec caget -n ID29:LocalRemote] 1]} {
	set intertLockCheck 1
	lappend intertLockCheckErr $inter
    }
    if ![string match [set a [exec cavget -list=ID29:feedback.VAL]] Ready] {
	set intertLockCheck 1
	lappend intertLockCheckErr $a	
    }
    if $intertLockCheck {
	APSMpReturn error "IEX interlock status is wrong, goto IEXinterlocks.adl for detail infomation.\n PV=$intertLockCheckErr"
    }

    APSMpStep "Step 3: Start IEX degauss and condition if it has been checked."
    if {$APSMpIEXInitialize(degauss) || $APSMpIEXInitialize(condition)} {
	if {[lindex [exec caget S35DCCT:currentCC] 1]>1} {
	    APSAlertBox .warning -errorMessage "Current > 1 mA, Dump beam first then continue."
	}
	exec caput ID29:DegaussMaskBx 1
	exec caput ID29:DegaussMaskBy 1
	exec caput ID29:DegaussMaskBxq 1
	exec caput ID29:DegaussMaskByq 1
	exec caput ID29:LinearCircular 0
	if {$APSMpIEXInitialize(degauss)} {
            APSMpStep "degaussing..."
	    exec caput ID29:CorrDegauss 1
	    exec caput ID29:Main_on_off.VAL  0
	    exec caput ID29:dGticks 40
	    exec caput ID29:dGnum 10
	    exec caput ID29:ConditioingSelect 0
	    exec caput ID29:DegaussSeq.PROC  1
            APSWaitWithUpdate -waitSeconds 180 -updateInterval 1
	}
	if {$APSMpIEXInitialize(condition)} {
            APSMpStep "conditioning ..."
	    exec caput ID29:CorrDegauss 0
	    exec caput ID29:Main_on_off.VAL  0
	    exec caput ID29:dGticks 100
	    exec caput ID29:dGnum 5
	    exec caput ID29:ConditioingSelect 1
	    exec caput ID29:DegaussSeq.PROC  1
	    APSWaitWithUpdate -waitSeconds 220 -updateInterval 1
	}
        APSMpStep "Turn off..."
	exec caput ID29:DegaussMaskBx 0
	exec caput ID29:DegaussMaskBy 0
	exec caput ID29:DegaussMaskBxq 0
	exec caput ID29:DegaussMaskByq 0
	exec caput ID29:CorrDegauss 0
	exec caput ID29:Main_on_off.VAL  1
    }
    APSMpReturn ok
}


proc APSSRMoveSCUID {args} {
    set ID ""
    set moveTo ""
    APSParseArguments {ID moveTo}
    
    if [catch {exec cavget -list=$ID:MainOn -num -pend=30} OnOff] {
        APSMpReturn error "APSSRMoveSCUID1: error reading $ID:MainOn: $OnOff"
    }
    if {$moveTo>50} {
        if $OnOff {
            if [catch {exec cawait  -interval=1 -timelimit=600 -waitFor=$ID:Gap,lower=[expr $moveTo - 1],upper=[expr $moveTo + 1] } result] {
                APSMpReturn error "APSSRMoveSCUID7: error reducing current of $ID: $result"
            }
            if [catch {exec cavput -list=$ID:Main_OnOff=0  -pend=30 } result] {
                APSMpReturn error "APSSRMoveSCUID7: error turning of SCU $ID: $result"
            }
        }
    } else {
        if !$OnOff {
            #ID01ds specail, has to open ID01us before turn it on
            if {$ID=="ID01ds"} {
                if [catch {exec cavput -list=ID01us:GapSet=180 -pend=20
                    exec cavput -list=ID01us:Start=1 -pend=10
                    exec cawait -waitFor=ID01us:Gap,lowerLimit=179,upperLimit=181 -timeLimit=600 } result] {
                    APSMpReturn error "APSSRMoveSCUID2: Error opening ID01us gap: $result"
                }
            }
            while {1} {
                #turn on SCU
                if [catch {exec cavput -list=$ID:Main_OnOff=1 -pend=20 } result] {
                    APSMpReturn error "APSSRMoveSCUID3: Error turnning on SCU1: $result"
                }
                
                APSWaitWithUpdate -waitSeconds 20 -updateInterval 1
                if [catch {APScavget -list=$ID:MainOn -num -pend=30} onOff] {
                    APSMpReturn error "APSSRMoveSCUID4: error reading $ID:MainOn: $onOff"
                }
                if $onOff {
                    break
                } else {
                    #wait another 20 seconds
                    for {set i 0} {$i<20} {incr i} {
                        if [catch {APScavget -list=$ID:MainOn -num -pend=30} onOff] {
                            APSMpReturn error "APSSRMoveSCUID4a: error reading $ID:MainOn: $onOff"
                        }
                        APSWaitWithUpdate -waitSeconds 1 -updateInterval 1
                        if $onOff {
                            break
                        }
                    }
                }
                if ${onOff} {
                    break
                }
                set answer [APSMultipleChoice [APSUniqueName .] -modal 1 \
                              -question "SCU $ID is not on yet, would you like turn in on again or abort" \
                              -returnList {1 0} \
                              -labelList {Turn_On_Again Abort}]
                if !$answer {
                    APSMpReturn error "APSSRMoveSCUID5: can not turn SCU1 on!"
                }
            }
        }
        #set to the desired value
        if [catch {exec cavput -list=$ID:GapSet=$moveTo -pend=30} result] {
            APSMpReturn error "APSSRMoveSCUID6: error change $ID gap to $moveTo: $result"
        }
    }
    APSMpReturn ok
}

proc APSSRMoveID01US {args} {
    set moveTo ""
    APSParseArguments {moveTo} 

    if {$moveTo<150} {
        #close ID01us -- has to turn off ID01ds (SCU1)
        if [catch {exec cavget -list=ID01ds:MainOn -num -pend=30} scu1OnOff] {
            APSMpReturn error "APSSRMoveID01US1: Error reading ID01ds:Main_OnOff: $scu1OnOff"
        }
        if {$scu1OnOff} {
            if [catch {exec cavput  -list=ID01ds:Main_OnOff=0  -pend=20
                exec cawait -waitFor=ID01ds:Gap,lowerLimit=179,upperLimit=181 -timeLimit=600 } result] {
                APSMpReturn error "APSSRMoveID01US2: Error opening ID01ds gap: $result"
            }
        }
    }
    if [catch {exec cavput -list=ID01us:GapSet=$moveTo -pend=20 
        exec cavput -list=ID01us:Start.VAL=1 -pend=20} result] {
        APSMpReturn error "APSSRMoveID01US3: Error moving ID01us to $moveTo: $result"
    }
    APSMpReturn ok
}


proc APSSRMoveIDGaps {args} {
    set IDList ""
    set moveTo 20
    set minGapList ""
    set lockedIDList ""
    set fixedIDList ""
    set fixedGapList ""
    set closeInterval 3
    #move provided IDList gap to 20mm, and open others if open is 1
    set open 0
    set pem 1
    APSParseArguments {IDList open moveTo minGapList deltaToMinGap lockedIDList fixedIDList fixedGapList closeInterval pem} 
    
    if ![llength $IDList] {
        return
    }
    
    if ![llength $lockedIDList] {
        set lockedIDList [APSSRGetLockedIDDevices]
    }
    set tmpRoot /tmp/[APSTmpString]
    
    foreach ID $fixedIDList {
        set index [lsearch $IDList $ID]
        if $index>=0 {
            set IDList [lreplace $IDList $index $index]
            set minGapList [lreplace $minGapList $index $index]
        }
    }

    if [string compare $moveTo "MinimumGap"]==0 {
        set IDList [concat $IDList $fixedIDList]
        set minGapList [concat $minGapList $fixedGapList]
        
        if [catch {exec sddsmakedataset -pipe=out \
                     -col=IDName,type=string -data=[join $IDList ,] \
                     -col=MoveGapTo,type=double -data=[join $minGapList ,] \
                     | sddsprocess -pipe -edit=col,ControlName,IDName,ei/:DeviceLimit.VAL/ \
                     | sddssort -pipe -col=IDName \
                     | sddscasr -pipe -save \
                     | sddsprocess -pipe=in $tmpRoot.set -match=col,CAError=n \
                     -reedit=col,ControlName,%/DeviceLimit/GapSet/ \
                     -scan=col,MinimumGap,ValueString,%f,type=float \
                     "-reprint=col,ValueString,%f,MoveGapTo" } result] {
            return -code error "APSSRMoveIDGaps1: $result"
        }
        if [catch {exec sddsprintout $tmpRoot.set $tmpRoot.printout \
                     -col=ControlName,format=%30s -col=MinimumGap,format=%.3f \
                     -col=MoveGapTo,format=%.3f } result] {
            return -code error  "APSSRMoveIDGaps2: $result"
        }
        global MoveGap
        set MoveGap 0
        APSFileDisplayWindow .gap -fileName $tmpRoot.printout -width 80 -modal 1 \
          -closeButton 0 -okButton 1 -cancelButton 1 -okCommand "set MoveGap 1;destroy .gap" \
          -cancelCommand "set MoveGap 0;destroy .gap" 
        if !$MoveGap {
            return -code error "APSSRMoveIDGaps3: Moving gaps to minimum was canceled!"
        }
        APSSetVarAndUpdate status "Moving gaps to their minimum gap values..."
        if [catch {exec sddsprocess $tmpRoot.set -reedit=col,ControlName,%/GapSet/TaperGapSet/ \
                     -nowarnings \
                     -reprint=col,ValueString,0  $tmpRoot.taper} result] {
            return -code error  "APSSRMoveIDGaps4: $result"
        }
    } else {
        set gapList [APSReplicateItem -item $moveTo -number [llength $IDList]]
        if [llength $fixedIDList] {
            set IDList [concat $IDList $fixedIDList]
            set gapList [concat $gapList $fixedGapList]
        }
        
        if [catch {exec sddsmakedataset -pipe=out -col=IDName,type=string -data=[join $IDList ,] \
                     -col=MoveGapTo,type=double -data=[join $gapList ,] \
                     | sddssort -pipe -col=IDName \
                     | sddsprocess -pipe=in $tmpRoot.set \
                     -edit=col,ControlName,IDName,ei/:GapSet.VAL/ \
                     -print=col,ValueString,%lf,MoveGapTo } result] {
            return -code error "APSSRMoveIDGaps5: $result"
        }
        APSSetVarAndUpdate status "Moving gaps to $moveTo mm..."
    }
    
    if [catch {exec sddsprocess $tmpRoot.set $tmpRoot.startmove \
                 -reedit=col,ControlName,%/GapSet/Start/ \
                 -reprint=col,ValueString,1 } result] {
        return -code error "APSSRMoveIDGaps6: $result"
    }
    if [string compare $moveTo "MinimumGap"]==0 {
        set rows [exec sdds2stream -rows=bar $tmpRoot.taper]
        if $rows {
            if [catch {exec sddscasr -restore $tmpRoot.taper } result] {
                return -code error  "APSSRMoveIDGaps7: $result"
            }
        }
    }
    if $open {
        #open other gaps 
        APSSetVarAndUpdate status "Open all other gaps..."
        APSMpStep "Open all other gaps..."
        set filterOpt ""
        set lockedIDList [concat $lockedIDList $fixedIDList]
        foreach ID $lockedIDList {
            if [string length $filterOpt] {
                append filterOpt ",GapName=$ID,!,&"
            } else {
                append filterOpt "-match=col,GapName=$ID,!"
            }
        }
        APSAddToTmpFileList -ID fullscan -fileList "$tmpRoot.open $tmpRoot.open.start"
        if [catch {eval exec sddsselect /home/helios/oagData/sr/IDs/SetGapTo180mm $tmpRoot.set \
                     -match=GapName=IDName -invert -pipe=out \
                       | sddsprocess -pipe=in $filterOpt $tmpRoot.open -reprint=col,IDName,%s,GapName
            exec sddscombine $tmpRoot.set $tmpRoot.open -merge $tmpRoot.set1} result] {
            return -code error  "APSSRMoveIDGaps8: $result"
        }
        exec mv $tmpRoot.set1 $tmpRoot.set
    }
    if [catch {exec sddscasr -restore $tmpRoot.set } result] {
       return -code error  "APSSRMoveIDGaps11: $result"
    }
    set moveList [join [exec sdds2stream -col=IDName $tmpRoot.set]]
    if $pem {
        if [catch {APSIDStaggerGaps -IDList $moveList} result] {
            return -code error "APSSRMoveIDGaps12: $result"
        }
    } else {
        #can not run in parallel without pem
        set scuList ""
        set otherGaps ""
        set moveID01us 0
        foreach ID $moveList {
            if {$ID=="ID01ds" || $ID=="ID06ds" || $ID=="ID07ds"} {
                lappend scuList $ID
            } elseif {$ID=="ID01us"} {
                set moveID01us 1
            } else {
                lappend otherGaps $ID
            }
        }
        if [llength $otherGaps] {
            if [catch {APSIDMoveRegularGaps -IDList $otherGaps -interval $closeInterval} result] {
                return -code error "APSSRMoveIDGaps13: $result"
            }
        }
        if [llength $scuList] {
            foreach ID $scuList {
                if [catch {exec cavget -list=$ID:GapSet -pend=20 -printErrors} value] {
                    return -code error "APSSRMoveIDGaps14: Error reading $ID:GapSet: $value"
                }
                if [catch {APSSRMoveSCUID -ID $ID -moveTo $value} result] {
                    return -code error "APSSRMoveIDGaps15: error moving SCU $ID: $result"
                }
            }
        }
        if $moveID01us {
            if [catch {exec cavget -list=ID01us:GapSet -pend=20 -printErrors} value] {
                return -code error "APSSRMoveIDGaps16: Error reading ID01us:GapSet: $value"
            }
            if [catch {APSSRMoveID01US -moveTo $value} result] {
                return -code error "APSSRMoveIDGaps17: error moving ID01us gap: $result"
            }
        }
    }
    set fileList [glob -nocomplain ${tmpRoot}.*]
    APSAddToTmpFileList -ID fullscan -fileList $fileList
    return $moveList
}
