# $Log: not supported by cvs2svn $
# Revision 1.13  2005/12/01 21:27:50  shang
# added clear, statusCallback, timeout and sourceID to APSAbortControllaw
#
# Revision 1.12  1998/05/08 16:26:07  emery
# Rendered obsolete procedures harmless by replacing the body with a return statement.
#
# Revision 1.11  1998/01/10 16:32:25  borland
# Changed the format of the run control descriptions to contain
# $plane-orbit.  Otherwise, steering scripts get confused and think
# orbit correction isn't running.
#
# Revision 1.10  1997/04/25 19:37:55  emery
# Added -lineLimit 1024 to APSExecLog
#
# Revision 1.9  1997/03/04 14:24:39  emery
# Added arguments to APSMpReturn.
#
# Revision 1.8  1997/03/01 20:49:44  borland
# Added globalRootname and fineRootname options to APSSRStartStandardCorrection,
# allowing use of these names and their run control records for other purposes.
# Added globalDescription and fineDescription options for same reason.  Not
# tested.
#
# Revision 1.7  1996/12/07 12:07:57  emery
# Replaced all return statements with appropriate APSMpReturn statements.
#
# Revision 1.6  1996/10/09 23:26:27  borland
# Replaced $plane with $coord in a few places inside the loop over planes.
#
# Revision 1.5  1996/10/09 22:43:37  borland
# Version that actually works.  More controls from PEM dialog.  Sets InUse
# flags on BPMs.
#
# Revision 1.4  1996/10/09 15:46:21  emery
# Fixed some despiking and gain defaults.
#
# Revision 1.3  1996/10/09 12:23:19  emery
# Corrected many misnamed procedures and variables, missing
# directories and variables. Ok to try with actual steering
# request.
#
# Revision 1.2  1996/10/08 21:46:45  borland
# Removed APSMpReturns and removed 'Mp' from names, since these aren't really
# machine procedures in the PEM sense.
#
# Revision 1.1  1996/10/08 16:58:46  emery
# First installation. Not tested.
#

proc APSSRStartStandardCorrection {args} {
    APSMpReturn error "APSSRStartStandardCorrection: This procedure no longer available."
}

proc APSStartSROrbitControllaw {args} {
    APSMpReturn error "APSSRStartSROrbitControllaw: This procedure no longer available."
}

proc APSAbortControllaw {args} {
    set runControlPV ""
    set clear 0
    set statusCallback ""
    set timeout 100
    set sourceID controllawAudit
    APSParseArguments {runControlPV clear statusCallback sourceID timeout}
    
    if ![string length $runControlPV] {
        APSMpReturn error "AbortControllaw: No runControlPV supplied."
    }
    # Don't need to abort if not running.
    if ![exec cavget -list=${runControlPV}.RUN -numerical] {
        APSMpReturn ok 0
    }
    if [string length $statusCallback] {
        eval $statusCallback {"Aborting $runControlPV..."}
    }
    if [string length $sourceID] {
        if [ catch {exec logMessage  -sourceId=$sourceID \
                      -tag=Instance $runControlPV -tag=Action Abort \
                  } result ] {
            APSAlertBox .alert -errorMessage "error with logMessage: $result"
        }
    }
    if [ catch {exec cavput -list=${runControlPV}.ABRT=1 -pend=30} result ] {
        APSMpReturn error "APSAbortControllaw: $result"
    }
    after 2000
    if $clear {
        if [string length $statusCallback] {
            eval $statusCallback {"Waiting for $runControlPV to clear..."}
        }
        if [catch {exec cawait -waitfor=$runControlPV.RUN,equal=0 -timeLimit=$timeout} result] {
            APSMpReturn error "Problem aborting $runControlPV: $result"
        }
        if [catch {exec cavput -list=$runControlPV.CLR=1 -pend=30} result] {
            APSMpReturn error "Problem clearing $runControlPV: $result"
        }
    }
    if [string length $statusCallback] {
        eval $statusCallback {"$runControlPV is aborted."}
    }
    APSMpReturn ok 0
}

proc APSSuspendControllaw {args} {
    set runControlPV ""
    APSParseArguments {runControlPV}

    if ![string length $runControlPV] {
        APSMpReturn error "AbortControllaw: No runControlPV supplied."
    }
    if [ catch {exec logMessage  -sourceId=controllawAudit\
                  -tag=Instance $runControlPV -tag=Action Suspend \
              } result ] {
        APSAlertBox .alert -errorMessage "error with logMessage: $result"
    }
    if [ catch {exec caput $runControlPV.SUSP 1} result ] {
        APSMpReturn error "APSAbortControllaw: $result"
    }
    APSMpReturn ok 0
}

proc APSResumeControllaw {args} {
    set runControlPV ""
    APSParseArguments {runControlPV}

    if ![string length $runControlPV] {
        APSMpReturn error "AbortControllaw: No runControlPV supplied."
    }
    if [ catch {exec logMessage  -sourceId=controllawAudit\
                  -tag=Instance $runControlPV -tag=Action Resume \
              } result ] {
        APSAlertBox .alert -errorMessage "error with logMessage: $result"
    }
    if [ catch {exec caput $runControlPV.SUSP 0} result ] {
        APSMpReturn error "APSAbortControllaw: $result"
    }
    APSMpReturn ok 0
}

