#
# $Log: not supported by cvs2svn $
# Revision 1.8  2009/07/28 17:57:18  soliday
# Updated to play the audio files on both Solaris and Linux.
#
# Revision 1.7  2004/06/08 15:56:46  emery
# Indented code.
#
# Revision 1.6  1999/02/08 21:06:46  soliday
# Replaced play with audioplay.
#
# Revision 1.5  1999/02/08 18:56:48  soliday
# Removed switch statement to allow easier addition of more sound files
#
# Revision 1.4  1996/01/16 21:20:18  saunders
# Added Log for CVS. Should have done this a long time ago.
#
#

proc APSSoundHelp {} {
    return "Usage: APSSound\n\[-type <string>\] where <string> is working, alert, or emergency\t\n\[-volume <string>\] from 1 to 100\t\n\[-iterations <string>\]\t\n\[-period <string>\] where <string> is in milliseconds or \"continuous\".\nPlays given sound type in background."
}

proc APSSound {args} {
    set type "working"
    set volume 50
    set iterations 1
    set period 2000
    
    APSStrictParseArguments {type volume iterations period}
    catch "after 0 APSPlaySound $type $volume $iterations $period"
}

proc APSPlaySound {type volume iteration period} {
    global apsSoundPath
    if {$period == "continuous"} {
        set bgFlag ""
    } else {
        set bgFlag "&"
    }
    global tcl_platform
    if {$tcl_platform(os) == "SunOS"} {
        set cmd "exec audioplay -i -v $volume $apsSoundPath/${type}.au $bgFlag"
    } else {
        set cmd "exec play -q -v 1.0 $apsSoundPath/${type}.au $bgFlag"
    }
    catch $cmd
    if {$iteration == 1} {
        return
    } elseif {$period == "continuous"} {
        APSPlaySound $type $volume [incr iteration -1] $period
    } else {
        catch "after $period APSPlaySound $type $volume [incr iteration -1] $period"
    }
    
}
